/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Activation Action</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.ActivationAction#getOffset <em>Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.ActivationAction#getPeriod <em>Period</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.ActivationAction#getDelay <em>Delay</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getActivationAction()
 * @model abstract="true"
 * @generated
 */
public interface ActivationAction extends EObject {
	/**
	 * Returns the value of the '<em><b>Offset</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Offset</em>' attribute.
	 * @see #setOffset(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getActivationAction_Offset()
	 * @model default="0"
	 * @generated
	 */
	int getOffset();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ActivationAction#getOffset <em>Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Offset</em>' attribute.
	 * @see #getOffset()
	 * @generated
	 */
	void setOffset(int value);

	/**
	 * Returns the value of the '<em><b>Period</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Period</em>' attribute.
	 * @see #setPeriod(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getActivationAction_Period()
	 * @model default="1"
	 * @generated
	 */
	int getPeriod();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ActivationAction#getPeriod <em>Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Period</em>' attribute.
	 * @see #getPeriod()
	 * @generated
	 */
	void setPeriod(int value);

	/**
	 * Returns the value of the '<em><b>Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Delay</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Delay</em>' containment reference.
	 * @see #setDelay(TimeDistribution)
	 * @see com.inchron.realtime.root.model.ModelPackage#getActivationAction_Delay()
	 * @model containment="true"
	 * @generated
	 */
	TimeDistribution getDelay();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.ActivationAction#getDelay <em>Delay</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Delay</em>' containment reference.
	 * @see #getDelay()
	 * @generated
	 */
	void setDelay(TimeDistribution value);

} // ActivationAction
