/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Call Graph</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.CallGraph#isEndlessLoop <em>Endless Loop</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.CallGraph#getGraphEntries <em>Graph Entries</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getCallGraph()
 * @model
 * @generated
 */
public interface CallGraph extends EObject {
	/**
	 * Returns the value of the '<em><b>Endless Loop</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Endless Loop</em>' attribute.
	 * @see #setEndlessLoop(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCallGraph_EndlessLoop()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isEndlessLoop();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.CallGraph#isEndlessLoop <em>Endless Loop</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Endless Loop</em>' attribute.
	 * @see #isEndlessLoop()
	 * @generated
	 */
	void setEndlessLoop(boolean value);

	/**
	 * Returns the value of the '<em><b>Graph Entries</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.GraphEntryBase}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Graph Entries</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Graph Entries</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getCallGraph_GraphEntries()
	 * @model containment="true"
	 * @generated
	 */
	EList<GraphEntryBase> getGraphEntries();

} // CallGraph
