/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import com.inchron.realtime.root.model.memory.Interconnect;
import com.inchron.realtime.root.model.memory.Memory;

import com.inchron.realtime.root.model.peripheral.Peripheral;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Cpu</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.Cpu#getCores <em>Cores</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Cpu#getCpuModel <em>Cpu Model</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Cpu#isReloadCpuModel <em>Reload Cpu Model</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Cpu#getHypervisor <em>Hypervisor</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Cpu#getInterconnects <em>Interconnects</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Cpu#getMemories <em>Memories</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Cpu#getMemoryRegions <em>Memory Regions</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Cpu#getPartitions <em>Partitions</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Cpu#getPeripherals <em>Peripherals</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getCpu()
 * @model
 * @generated
 */
public interface Cpu extends ModelObject, TraceObject, LoadResource, ClockUser {
	/**
	 * Returns the value of the '<em><b>Cores</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.CpuCore}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cores</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getCpu_Cores()
	 * @model containment="true" required="true" ordered="false"
	 * @generated
	 */
	EList<CpuCore> getCores();

	/**
	 * Returns the value of the '<em><b>Cpu Model</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cpu Model</em>' attribute.
	 * @see #setCpuModel(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCpu_CpuModel()
	 * @model
	 * @generated
	 */
	String getCpuModel();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Cpu#getCpuModel <em>Cpu Model</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cpu Model</em>' attribute.
	 * @see #getCpuModel()
	 * @generated
	 */
	void setCpuModel(String value);

	/**
	 * Returns the value of the '<em><b>Reload Cpu Model</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Reload Cpu Model</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Reload Cpu Model</em>' attribute.
	 * @see #setReloadCpuModel(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCpu_ReloadCpuModel()
	 * @model default="false"
	 * @generated
	 */
	boolean isReloadCpuModel();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Cpu#isReloadCpuModel <em>Reload Cpu Model</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Reload Cpu Model</em>' attribute.
	 * @see #isReloadCpuModel()
	 * @generated
	 */
	void setReloadCpuModel(boolean value);

	/**
	 * Returns the value of the '<em><b>Hypervisor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Hypervisor</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Hypervisor</em>' containment reference.
	 * @see #setHypervisor(HyperVisorConfig)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCpu_Hypervisor()
	 * @model containment="true"
	 * @generated
	 */
	HyperVisorConfig getHypervisor();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Cpu#getHypervisor <em>Hypervisor</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Hypervisor</em>' containment reference.
	 * @see #getHypervisor()
	 * @generated
	 */
	void setHypervisor(HyperVisorConfig value);

	/**
	 * Returns the value of the '<em><b>Interconnects</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.memory.Interconnect}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interconnects</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interconnects</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getCpu_Interconnects()
	 * @model containment="true"
	 * @generated
	 */
	EList<Interconnect> getInterconnects();

	/**
	 * Returns the value of the '<em><b>Memories</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.memory.Memory}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Memories</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Memories</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getCpu_Memories()
	 * @model containment="true"
	 * @generated
	 */
	EList<Memory> getMemories();

	/**
	 * Returns the value of the '<em><b>Memory Regions</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.MemoryRegion}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Memory Regions</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Memory Regions</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getCpu_MemoryRegions()
	 * @model containment="true"
	 * @generated
	 */
	EList<MemoryRegion> getMemoryRegions();

	/**
	 * Returns the value of the '<em><b>Partitions</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Partition}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Partitions</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getCpu_Partitions()
	 * @model containment="true"
	 * @generated
	 */
	EList<Partition> getPartitions();

	/**
	 * Returns the value of the '<em><b>Peripherals</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.peripheral.Peripheral}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Peripherals</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Peripherals</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getCpu_Peripherals()
	 * @model containment="true"
	 * @generated
	 */
	EList<Peripheral> getPeripherals();

} // Cpu
