/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import com.inchron.realtime.root.model.memory.InitiatorPort;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Cpu Core</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.CpuCore#getPrescaler <em>Prescaler</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.CpuCore#getBitWidth <em>Bit Width</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.CpuCore#getConnectedSlave <em>Connected Slave</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getCpuCore()
 * @model
 * @generated
 */
public interface CpuCore extends ModelObject, TraceObject, LoadResource {
	/**
	 * Returns the value of the '<em><b>Prescaler</b></em>' attribute.
	 * The default value is <code>"1.0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Prescaler</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Prescaler</em>' attribute.
	 * @see #setPrescaler(double)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCpuCore_Prescaler()
	 * @model default="1.0"
	 * @generated
	 */
	double getPrescaler();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.CpuCore#getPrescaler <em>Prescaler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Prescaler</em>' attribute.
	 * @see #getPrescaler()
	 * @generated
	 */
	void setPrescaler(double value);

	/**
	 * Returns the value of the '<em><b>Bit Width</b></em>' attribute.
	 * The default value is <code>"32"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Bit Width</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Bit Width</em>' attribute.
	 * @see #setBitWidth(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCpuCore_BitWidth()
	 * @model default="32"
	 * @generated
	 */
	int getBitWidth();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.CpuCore#getBitWidth <em>Bit Width</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Bit Width</em>' attribute.
	 * @see #getBitWidth()
	 * @generated
	 */
	void setBitWidth(int value);

	/**
	 * Returns the value of the '<em><b>Connected Slave</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Connected Slave</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Connected Slave</em>' containment reference.
	 * @see #setConnectedSlave(InitiatorPort)
	 * @see com.inchron.realtime.root.model.ModelPackage#getCpuCore_ConnectedSlave()
	 * @model containment="true" required="true"
	 * @generated
	 */
	InitiatorPort getConnectedSlave();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.CpuCore#getConnectedSlave <em>Connected Slave</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Connected Slave</em>' containment reference.
	 * @see #getConnectedSlave()
	 * @generated
	 */
	void setConnectedSlave(InitiatorPort value);

} // CpuCore
