/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Data Flow</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.DataFlow#getEdges <em>Edges</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.DataFlow#getReferences <em>References</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlow()
 * @model
 * @generated
 */
public interface DataFlow extends EventChain {
	/**
	 * Returns the value of the '<em><b>Edges</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.DataFlowEdge}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Edges</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Edges</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlow_Edges()
	 * @model containment="true"
	 * @generated
	 */
	EList<DataFlowEdge> getEdges();

	/**
	 * Returns the value of the '<em><b>References</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.DataFlowReference}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>References</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>References</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlow_References()
	 * @model containment="true"
	 * @generated
	 */
	EList<DataFlowReference> getReferences();

} // DataFlow
