/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Discrete Distribution Entry</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.DiscreteDistributionEntry#getCount <em>Count</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.DiscreteDistributionEntry#getExecTime <em>Exec Time</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getDiscreteDistributionEntry()
 * @model
 * @generated
 */
public interface DiscreteDistributionEntry extends EObject {
	/**
	 * Returns the value of the '<em><b>Count</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Count</em>' attribute.
	 * @see #setCount(long)
	 * @see com.inchron.realtime.root.model.ModelPackage#getDiscreteDistributionEntry_Count()
	 * @model default="1"
	 * @generated
	 */
	long getCount();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.DiscreteDistributionEntry#getCount <em>Count</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Count</em>' attribute.
	 * @see #getCount()
	 * @generated
	 */
	void setCount(long value);

	/**
	 * Returns the value of the '<em><b>Exec Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Exec Time</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Exec Time</em>' containment reference.
	 * @see #setExecTime(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getDiscreteDistributionEntry_ExecTime()
	 * @model containment="true" required="true" ordered="false"
	 * @generated
	 */
	Time getExecTime();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.DiscreteDistributionEntry#getExecTime <em>Exec Time</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Exec Time</em>' containment reference.
	 * @see #getExecTime()
	 * @generated
	 */
	void setExecTime(Time value);

} // DiscreteDistributionEntry
