/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Rtos Config</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.RtosConfig#getSchedulables <em>Schedulables</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.RtosConfig#getSemaphores <em>Semaphores</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.RtosConfig#getSpinlocks <em>Spinlocks</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.RtosConfig#getEvents <em>Events</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getRtosConfig()
 * @model
 * @generated
 */
public interface RtosConfig extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Schedulables</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Schedulable}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Schedulables</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getRtosConfig_Schedulables()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<Schedulable> getSchedulables();

	/**
	 * Returns the value of the '<em><b>Semaphores</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Semaphore}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Semaphores</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Semaphores</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getRtosConfig_Semaphores()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<Semaphore> getSemaphores();

	/**
	 * Returns the value of the '<em><b>Spinlocks</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Spinlock}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Spinlocks</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Spinlocks</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getRtosConfig_Spinlocks()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<Spinlock> getSpinlocks();

	/**
	 * Returns the value of the '<em><b>Events</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Event}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Events</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Events</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getRtosConfig_Events()
	 * @model containment="true"
	 * @generated
	 */
	EList<Event> getEvents();

} // RtosConfig
