/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import com.inchron.realtime.root.model.memory.ExplicitDataAccess;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Variable Access</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.VariableAccess#getDataAccess <em>Data Access</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableAccess#getElements <em>Elements</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getVariableAccess()
 * @model abstract="true"
 * @generated
 */
public interface VariableAccess extends EventChainStep, CallSequenceItem {

	/**
	 * Returns the value of the '<em><b>Data Access</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Data Access</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Data Access</em>' containment reference.
	 * @see #setDataAccess(ExplicitDataAccess)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableAccess_DataAccess()
	 * @model containment="true"
	 * @generated
	 */
	ExplicitDataAccess getDataAccess();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableAccess#getDataAccess <em>Data Access</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Data Access</em>' containment reference.
	 * @see #getDataAccess()
	 * @generated
	 */
	void setDataAccess(ExplicitDataAccess value);

	/**
	 * Returns the value of the '<em><b>Elements</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Elements</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Elements</em>' attribute.
	 * @see #setElements(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableAccess_Elements()
	 * @model default="1" required="true"
	 * @generated
	 */
	int getElements();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableAccess#getElements <em>Elements</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Elements</em>' attribute.
	 * @see #getElements()
	 * @generated
	 */
	void setElements(int value);
} // VariableAccess
