/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Variable Read Access</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#getConnection <em>Connection</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#isDataMustBeNew <em>Data Must Be New</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#getIndex <em>Index</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#getMinElements <em>Min Elements</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#getPolicy <em>Policy</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.VariableReadAccess#getType <em>Type</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess()
 * @model
 * @generated
 */
public interface VariableReadAccess extends VariableAccess {
	/**
	 * Returns the value of the '<em><b>Connection</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link com.inchron.realtime.root.model.DataFlowConnection#getRequesters <em>Requesters</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Connection</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Connection</em>' reference.
	 * @see #setConnection(DataFlowConnection)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_Connection()
	 * @see com.inchron.realtime.root.model.DataFlowConnection#getRequesters
	 * @model opposite="requesters"
	 * @generated
	 */
	DataFlowConnection getConnection();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#getConnection <em>Connection</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Connection</em>' reference.
	 * @see #getConnection()
	 * @generated
	 */
	void setConnection(DataFlowConnection value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The default value is <code>"Generic"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.VariableReadAccessType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.VariableReadAccessType
	 * @see #setType(VariableReadAccessType)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_Type()
	 * @model default="Generic" required="true"
	 * @generated
	 */
	VariableReadAccessType getType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.VariableReadAccessType
	 * @see #getType()
	 * @generated
	 */
	void setType(VariableReadAccessType value);

	/**
	 * Returns the value of the '<em><b>Index</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Index</em>' attribute.
	 * @see #setIndex(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_Index()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getIndex();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#getIndex <em>Index</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Index</em>' attribute.
	 * @see #getIndex()
	 * @generated
	 */
	void setIndex(int value);

	/**
	 * Returns the value of the '<em><b>Min Elements</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Min Elements</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Min Elements</em>' attribute.
	 * @see #setMinElements(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_MinElements()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getMinElements();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#getMinElements <em>Min Elements</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Min Elements</em>' attribute.
	 * @see #getMinElements()
	 * @generated
	 */
	void setMinElements(int value);

	/**
	 * Returns the value of the '<em><b>Policy</b></em>' attribute.
	 * The default value is <code>"FIFOTake"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.VariableReadAccessPolicy}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Policy</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Policy</em>' attribute.
	 * @see com.inchron.realtime.root.model.VariableReadAccessPolicy
	 * @see #setPolicy(VariableReadAccessPolicy)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_Policy()
	 * @model default="FIFOTake" required="true"
	 * @generated
	 */
	VariableReadAccessPolicy getPolicy();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#getPolicy <em>Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Policy</em>' attribute.
	 * @see com.inchron.realtime.root.model.VariableReadAccessPolicy
	 * @see #getPolicy()
	 * @generated
	 */
	void setPolicy(VariableReadAccessPolicy value);

	/**
	 * Returns the value of the '<em><b>Data Must Be New</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Data Must Be New</em>' attribute.
	 * @see #setDataMustBeNew(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getVariableReadAccess_DataMustBeNew()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isDataMustBeNew();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.VariableReadAccess#isDataMustBeNew <em>Data Must Be New</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Data Must Be New</em>' attribute.
	 * @see #isDataMustBeNew()
	 * @generated
	 */
	void setDataMustBeNew(boolean value);

} // VariableReadAccess
