/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar.impl;

import com.inchron.realtime.root.model.autosar.AutosarPackage;
import com.inchron.realtime.root.model.autosar.OsAlarm;
import com.inchron.realtime.root.model.autosar.OsAlarmAction;
import com.inchron.realtime.root.model.autosar.OsCounter;

import com.inchron.realtime.root.model.impl.ModelObjectImpl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Os Alarm</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsAlarmImpl#getAction <em>Action</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsAlarmImpl#getAutostartAppMode <em>Autostart App Mode</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsAlarmImpl#getAutostartCycleTime <em>Autostart Cycle Time</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsAlarmImpl#getAutostartAlarmTime <em>Autostart Alarm Time</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsAlarmImpl#isAutostart <em>Autostart</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsAlarmImpl#getCounter <em>Counter</em>}</li>
 * </ul>
 *
 * @generated
 */
public class OsAlarmImpl extends ModelObjectImpl implements OsAlarm {
	/**
	 * The cached value of the '{@link #getAction() <em>Action</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAction()
	 * @generated
	 * @ordered
	 */
	protected OsAlarmAction action;

	/**
	 * The default value of the '{@link #getAutostartAppMode() <em>Autostart App Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAutostartAppMode()
	 * @generated
	 * @ordered
	 */
	protected static final String AUTOSTART_APP_MODE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getAutostartAppMode() <em>Autostart App Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAutostartAppMode()
	 * @generated
	 * @ordered
	 */
	protected String autostartAppMode = AUTOSTART_APP_MODE_EDEFAULT;

	/**
	 * The default value of the '{@link #getAutostartCycleTime() <em>Autostart Cycle Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAutostartCycleTime()
	 * @generated
	 * @ordered
	 */
	protected static final long AUTOSTART_CYCLE_TIME_EDEFAULT = 1L;

	/**
	 * The cached value of the '{@link #getAutostartCycleTime() <em>Autostart Cycle Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAutostartCycleTime()
	 * @generated
	 * @ordered
	 */
	protected long autostartCycleTime = AUTOSTART_CYCLE_TIME_EDEFAULT;

	/**
	 * The default value of the '{@link #getAutostartAlarmTime() <em>Autostart Alarm Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAutostartAlarmTime()
	 * @generated
	 * @ordered
	 */
	protected static final long AUTOSTART_ALARM_TIME_EDEFAULT = 0L;

	/**
	 * The cached value of the '{@link #getAutostartAlarmTime() <em>Autostart Alarm Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAutostartAlarmTime()
	 * @generated
	 * @ordered
	 */
	protected long autostartAlarmTime = AUTOSTART_ALARM_TIME_EDEFAULT;

	/**
	 * The default value of the '{@link #isAutostart() <em>Autostart</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isAutostart()
	 * @generated
	 * @ordered
	 */
	protected static final boolean AUTOSTART_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isAutostart() <em>Autostart</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isAutostart()
	 * @generated
	 * @ordered
	 */
	protected boolean autostart = AUTOSTART_EDEFAULT;

	/**
	 * The cached value of the '{@link #getCounter() <em>Counter</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCounter()
	 * @generated
	 * @ordered
	 */
	protected OsCounter counter;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OsAlarmImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AutosarPackage.Literals.OS_ALARM;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsAlarmAction getAction() {
		return action;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetAction(OsAlarmAction newAction, NotificationChain msgs) {
		OsAlarmAction oldAction = action;
		action = newAction;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_ALARM__ACTION, oldAction, newAction);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAction(OsAlarmAction newAction) {
		if (newAction != action) {
			NotificationChain msgs = null;
			if (action != null)
				msgs = ((InternalEObject)action).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - AutosarPackage.OS_ALARM__ACTION, null, msgs);
			if (newAction != null)
				msgs = ((InternalEObject)newAction).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - AutosarPackage.OS_ALARM__ACTION, null, msgs);
			msgs = basicSetAction(newAction, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_ALARM__ACTION, newAction, newAction));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getAutostartAppMode() {
		return autostartAppMode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAutostartAppMode(String newAutostartAppMode) {
		String oldAutostartAppMode = autostartAppMode;
		autostartAppMode = newAutostartAppMode;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_ALARM__AUTOSTART_APP_MODE, oldAutostartAppMode, autostartAppMode));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getAutostartCycleTime() {
		return autostartCycleTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAutostartCycleTime(long newAutostartCycleTime) {
		long oldAutostartCycleTime = autostartCycleTime;
		autostartCycleTime = newAutostartCycleTime;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_ALARM__AUTOSTART_CYCLE_TIME, oldAutostartCycleTime, autostartCycleTime));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getAutostartAlarmTime() {
		return autostartAlarmTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAutostartAlarmTime(long newAutostartAlarmTime) {
		long oldAutostartAlarmTime = autostartAlarmTime;
		autostartAlarmTime = newAutostartAlarmTime;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_ALARM__AUTOSTART_ALARM_TIME, oldAutostartAlarmTime, autostartAlarmTime));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isAutostart() {
		return autostart;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAutostart(boolean newAutostart) {
		boolean oldAutostart = autostart;
		autostart = newAutostart;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_ALARM__AUTOSTART, oldAutostart, autostart));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsCounter getCounter() {
		if (counter != null && counter.eIsProxy()) {
			InternalEObject oldCounter = (InternalEObject)counter;
			counter = (OsCounter)eResolveProxy(oldCounter);
			if (counter != oldCounter) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AutosarPackage.OS_ALARM__COUNTER, oldCounter, counter));
			}
		}
		return counter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsCounter basicGetCounter() {
		return counter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCounter(OsCounter newCounter) {
		OsCounter oldCounter = counter;
		counter = newCounter;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_ALARM__COUNTER, oldCounter, counter));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AutosarPackage.OS_ALARM__ACTION:
				return basicSetAction(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AutosarPackage.OS_ALARM__ACTION:
				return getAction();
			case AutosarPackage.OS_ALARM__AUTOSTART_APP_MODE:
				return getAutostartAppMode();
			case AutosarPackage.OS_ALARM__AUTOSTART_CYCLE_TIME:
				return getAutostartCycleTime();
			case AutosarPackage.OS_ALARM__AUTOSTART_ALARM_TIME:
				return getAutostartAlarmTime();
			case AutosarPackage.OS_ALARM__AUTOSTART:
				return isAutostart();
			case AutosarPackage.OS_ALARM__COUNTER:
				if (resolve) return getCounter();
				return basicGetCounter();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AutosarPackage.OS_ALARM__ACTION:
				setAction((OsAlarmAction)newValue);
				return;
			case AutosarPackage.OS_ALARM__AUTOSTART_APP_MODE:
				setAutostartAppMode((String)newValue);
				return;
			case AutosarPackage.OS_ALARM__AUTOSTART_CYCLE_TIME:
				setAutostartCycleTime((Long)newValue);
				return;
			case AutosarPackage.OS_ALARM__AUTOSTART_ALARM_TIME:
				setAutostartAlarmTime((Long)newValue);
				return;
			case AutosarPackage.OS_ALARM__AUTOSTART:
				setAutostart((Boolean)newValue);
				return;
			case AutosarPackage.OS_ALARM__COUNTER:
				setCounter((OsCounter)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AutosarPackage.OS_ALARM__ACTION:
				setAction((OsAlarmAction)null);
				return;
			case AutosarPackage.OS_ALARM__AUTOSTART_APP_MODE:
				setAutostartAppMode(AUTOSTART_APP_MODE_EDEFAULT);
				return;
			case AutosarPackage.OS_ALARM__AUTOSTART_CYCLE_TIME:
				setAutostartCycleTime(AUTOSTART_CYCLE_TIME_EDEFAULT);
				return;
			case AutosarPackage.OS_ALARM__AUTOSTART_ALARM_TIME:
				setAutostartAlarmTime(AUTOSTART_ALARM_TIME_EDEFAULT);
				return;
			case AutosarPackage.OS_ALARM__AUTOSTART:
				setAutostart(AUTOSTART_EDEFAULT);
				return;
			case AutosarPackage.OS_ALARM__COUNTER:
				setCounter((OsCounter)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AutosarPackage.OS_ALARM__ACTION:
				return action != null;
			case AutosarPackage.OS_ALARM__AUTOSTART_APP_MODE:
				return AUTOSTART_APP_MODE_EDEFAULT == null ? autostartAppMode != null : !AUTOSTART_APP_MODE_EDEFAULT.equals(autostartAppMode);
			case AutosarPackage.OS_ALARM__AUTOSTART_CYCLE_TIME:
				return autostartCycleTime != AUTOSTART_CYCLE_TIME_EDEFAULT;
			case AutosarPackage.OS_ALARM__AUTOSTART_ALARM_TIME:
				return autostartAlarmTime != AUTOSTART_ALARM_TIME_EDEFAULT;
			case AutosarPackage.OS_ALARM__AUTOSTART:
				return autostart != AUTOSTART_EDEFAULT;
			case AutosarPackage.OS_ALARM__COUNTER:
				return counter != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (autostartAppMode: ");
		result.append(autostartAppMode);
		result.append(", autostartCycleTime: ");
		result.append(autostartCycleTime);
		result.append(", autostartAlarmTime: ");
		result.append(autostartAlarmTime);
		result.append(", autostart: ");
		result.append(autostart);
		result.append(')');
		return result.toString();
	}

} //OsAlarmImpl
