/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar.impl;

import com.inchron.realtime.root.model.autosar.AutosarPackage;
import com.inchron.realtime.root.model.autosar.OsCounter;
import com.inchron.realtime.root.model.autosar.OsExpiryPoint;
import com.inchron.realtime.root.model.autosar.OsScheduleTable;
import com.inchron.realtime.root.model.autosar.OsScheduleTableStartType;

import com.inchron.realtime.root.model.impl.ModelObjectImpl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Os Schedule Table</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsScheduleTableImpl#isAutostart <em>Autostart</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsScheduleTableImpl#getCounter <em>Counter</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsScheduleTableImpl#getDuration <em>Duration</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsScheduleTableImpl#getExpiryPoints <em>Expiry Points</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsScheduleTableImpl#isRepeating <em>Repeating</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.impl.OsScheduleTableImpl#getStartType <em>Start Type</em>}</li>
 * </ul>
 *
 * @generated
 */
public class OsScheduleTableImpl extends ModelObjectImpl implements OsScheduleTable {
	/**
	 * The default value of the '{@link #isAutostart() <em>Autostart</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isAutostart()
	 * @generated
	 * @ordered
	 */
	protected static final boolean AUTOSTART_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isAutostart() <em>Autostart</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isAutostart()
	 * @generated
	 * @ordered
	 */
	protected boolean autostart = AUTOSTART_EDEFAULT;

	/**
	 * The cached value of the '{@link #getCounter() <em>Counter</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCounter()
	 * @generated
	 * @ordered
	 */
	protected OsCounter counter;

	/**
	 * The default value of the '{@link #getDuration() <em>Duration</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDuration()
	 * @generated
	 * @ordered
	 */
	protected static final long DURATION_EDEFAULT = 1L;

	/**
	 * The cached value of the '{@link #getDuration() <em>Duration</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDuration()
	 * @generated
	 * @ordered
	 */
	protected long duration = DURATION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getExpiryPoints() <em>Expiry Points</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExpiryPoints()
	 * @generated
	 * @ordered
	 */
	protected EList<OsExpiryPoint> expiryPoints;

	/**
	 * The default value of the '{@link #isRepeating() <em>Repeating</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isRepeating()
	 * @generated
	 * @ordered
	 */
	protected static final boolean REPEATING_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isRepeating() <em>Repeating</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isRepeating()
	 * @generated
	 * @ordered
	 */
	protected boolean repeating = REPEATING_EDEFAULT;

	/**
	 * The default value of the '{@link #getStartType() <em>Start Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartType()
	 * @generated
	 * @ordered
	 */
	protected static final OsScheduleTableStartType START_TYPE_EDEFAULT = OsScheduleTableStartType.ABSOLUTE;

	/**
	 * The cached value of the '{@link #getStartType() <em>Start Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartType()
	 * @generated
	 * @ordered
	 */
	protected OsScheduleTableStartType startType = START_TYPE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OsScheduleTableImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AutosarPackage.Literals.OS_SCHEDULE_TABLE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isAutostart() {
		return autostart;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAutostart(boolean newAutostart) {
		boolean oldAutostart = autostart;
		autostart = newAutostart;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_SCHEDULE_TABLE__AUTOSTART, oldAutostart, autostart));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsCounter getCounter() {
		if (counter != null && counter.eIsProxy()) {
			InternalEObject oldCounter = (InternalEObject)counter;
			counter = (OsCounter)eResolveProxy(oldCounter);
			if (counter != oldCounter) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AutosarPackage.OS_SCHEDULE_TABLE__COUNTER, oldCounter, counter));
			}
		}
		return counter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsCounter basicGetCounter() {
		return counter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCounter(OsCounter newCounter) {
		OsCounter oldCounter = counter;
		counter = newCounter;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_SCHEDULE_TABLE__COUNTER, oldCounter, counter));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public long getDuration() {
		return duration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDuration(long newDuration) {
		long oldDuration = duration;
		duration = newDuration;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_SCHEDULE_TABLE__DURATION, oldDuration, duration));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<OsExpiryPoint> getExpiryPoints() {
		if (expiryPoints == null) {
			expiryPoints = new EObjectContainmentEList<OsExpiryPoint>(OsExpiryPoint.class, this, AutosarPackage.OS_SCHEDULE_TABLE__EXPIRY_POINTS);
		}
		return expiryPoints;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isRepeating() {
		return repeating;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRepeating(boolean newRepeating) {
		boolean oldRepeating = repeating;
		repeating = newRepeating;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_SCHEDULE_TABLE__REPEATING, oldRepeating, repeating));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OsScheduleTableStartType getStartType() {
		return startType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartType(OsScheduleTableStartType newStartType) {
		OsScheduleTableStartType oldStartType = startType;
		startType = newStartType == null ? START_TYPE_EDEFAULT : newStartType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AutosarPackage.OS_SCHEDULE_TABLE__START_TYPE, oldStartType, startType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AutosarPackage.OS_SCHEDULE_TABLE__EXPIRY_POINTS:
				return ((InternalEList<?>)getExpiryPoints()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AutosarPackage.OS_SCHEDULE_TABLE__AUTOSTART:
				return isAutostart();
			case AutosarPackage.OS_SCHEDULE_TABLE__COUNTER:
				if (resolve) return getCounter();
				return basicGetCounter();
			case AutosarPackage.OS_SCHEDULE_TABLE__DURATION:
				return getDuration();
			case AutosarPackage.OS_SCHEDULE_TABLE__EXPIRY_POINTS:
				return getExpiryPoints();
			case AutosarPackage.OS_SCHEDULE_TABLE__REPEATING:
				return isRepeating();
			case AutosarPackage.OS_SCHEDULE_TABLE__START_TYPE:
				return getStartType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AutosarPackage.OS_SCHEDULE_TABLE__AUTOSTART:
				setAutostart((Boolean)newValue);
				return;
			case AutosarPackage.OS_SCHEDULE_TABLE__COUNTER:
				setCounter((OsCounter)newValue);
				return;
			case AutosarPackage.OS_SCHEDULE_TABLE__DURATION:
				setDuration((Long)newValue);
				return;
			case AutosarPackage.OS_SCHEDULE_TABLE__EXPIRY_POINTS:
				getExpiryPoints().clear();
				getExpiryPoints().addAll((Collection<? extends OsExpiryPoint>)newValue);
				return;
			case AutosarPackage.OS_SCHEDULE_TABLE__REPEATING:
				setRepeating((Boolean)newValue);
				return;
			case AutosarPackage.OS_SCHEDULE_TABLE__START_TYPE:
				setStartType((OsScheduleTableStartType)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AutosarPackage.OS_SCHEDULE_TABLE__AUTOSTART:
				setAutostart(AUTOSTART_EDEFAULT);
				return;
			case AutosarPackage.OS_SCHEDULE_TABLE__COUNTER:
				setCounter((OsCounter)null);
				return;
			case AutosarPackage.OS_SCHEDULE_TABLE__DURATION:
				setDuration(DURATION_EDEFAULT);
				return;
			case AutosarPackage.OS_SCHEDULE_TABLE__EXPIRY_POINTS:
				getExpiryPoints().clear();
				return;
			case AutosarPackage.OS_SCHEDULE_TABLE__REPEATING:
				setRepeating(REPEATING_EDEFAULT);
				return;
			case AutosarPackage.OS_SCHEDULE_TABLE__START_TYPE:
				setStartType(START_TYPE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AutosarPackage.OS_SCHEDULE_TABLE__AUTOSTART:
				return autostart != AUTOSTART_EDEFAULT;
			case AutosarPackage.OS_SCHEDULE_TABLE__COUNTER:
				return counter != null;
			case AutosarPackage.OS_SCHEDULE_TABLE__DURATION:
				return duration != DURATION_EDEFAULT;
			case AutosarPackage.OS_SCHEDULE_TABLE__EXPIRY_POINTS:
				return expiryPoints != null && !expiryPoints.isEmpty();
			case AutosarPackage.OS_SCHEDULE_TABLE__REPEATING:
				return repeating != REPEATING_EDEFAULT;
			case AutosarPackage.OS_SCHEDULE_TABLE__START_TYPE:
				return startType != START_TYPE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (autostart: ");
		result.append(autostart);
		result.append(", duration: ");
		result.append(duration);
		result.append(", repeating: ");
		result.append(repeating);
		result.append(", startType: ");
		result.append(startType);
		result.append(')');
		return result.toString();
	}

} //OsScheduleTableImpl
