/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi;

import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.fmi.FmiFactory
 * @model kind="package"
 * @generated
 */
public interface FmiPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "fmi";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://inchron.com/realtime/root/2.98.5/model/fmi";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "fmi";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	FmiPackage eINSTANCE = com.inchron.realtime.root.model.fmi.impl.FmiPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.fmi.impl.FMIVariablesImpl <em>FMI Variables</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.fmi.impl.FMIVariablesImpl
	 * @see com.inchron.realtime.root.model.fmi.impl.FmiPackageImpl#getFMIVariables()
	 * @generated
	 */
	int FMI_VARIABLES = 0;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FMI_VARIABLES__INTRINSIC_ID = PeripheralPackage.PERIPHERAL__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FMI_VARIABLES__NAME = PeripheralPackage.PERIPHERAL__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FMI_VARIABLES__OBJECT_ID = PeripheralPackage.PERIPHERAL__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Exactness</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FMI_VARIABLES__EXACTNESS = PeripheralPackage.PERIPHERAL__EXACTNESS;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FMI_VARIABLES__EVENTS = PeripheralPackage.PERIPHERAL__EVENTS;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FMI_VARIABLES__PORTS = PeripheralPackage.PERIPHERAL__PORTS;

	/**
	 * The feature id for the '<em><b>Address Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FMI_VARIABLES__ADDRESS_RANGE = PeripheralPackage.PERIPHERAL__ADDRESS_RANGE;

	/**
	 * The number of structural features of the '<em>FMI Variables</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FMI_VARIABLES_FEATURE_COUNT = PeripheralPackage.PERIPHERAL_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Is Compatible</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FMI_VARIABLES___IS_COMPATIBLE__ABSTRACTPERIPHERAL = PeripheralPackage.PERIPHERAL___IS_COMPATIBLE__ABSTRACTPERIPHERAL;

	/**
	 * The number of operations of the '<em>FMI Variables</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FMI_VARIABLES_OPERATION_COUNT = PeripheralPackage.PERIPHERAL_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.fmi.impl.IntegerAttributesImpl <em>Integer Attributes</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.fmi.impl.IntegerAttributesImpl
	 * @see com.inchron.realtime.root.model.fmi.impl.FmiPackageImpl#getIntegerAttributes()
	 * @generated
	 */
	int INTEGER_ATTRIBUTES = 1;

	/**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER_ATTRIBUTES__MAX = 0;

	/**
	 * The feature id for the '<em><b>Min</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER_ATTRIBUTES__MIN = 1;

	/**
	 * The feature id for the '<em><b>Quantity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER_ATTRIBUTES__QUANTITY = 2;

	/**
	 * The number of structural features of the '<em>Integer Attributes</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER_ATTRIBUTES_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Integer Attributes</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER_ATTRIBUTES_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.fmi.impl.ModelDescriptionImpl <em>Model Description</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.fmi.impl.ModelDescriptionImpl
	 * @see com.inchron.realtime.root.model.fmi.impl.FmiPackageImpl#getModelDescription()
	 * @generated
	 */
	int MODEL_DESCRIPTION = 2;

	/**
	 * The feature id for the '<em><b>Seed</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_DESCRIPTION__SEED = 0;

	/**
	 * The feature id for the '<em><b>Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_DESCRIPTION__TIME = 1;

	/**
	 * The feature id for the '<em><b>Type Definitions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_DESCRIPTION__TYPE_DEFINITIONS = 2;

	/**
	 * The feature id for the '<em><b>Unit Definitions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_DESCRIPTION__UNIT_DEFINITIONS = 3;

	/**
	 * The number of structural features of the '<em>Model Description</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_DESCRIPTION_FEATURE_COUNT = 4;

	/**
	 * The number of operations of the '<em>Model Description</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_DESCRIPTION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.fmi.impl.RealAttributesImpl <em>Real Attributes</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.fmi.impl.RealAttributesImpl
	 * @see com.inchron.realtime.root.model.fmi.impl.FmiPackageImpl#getRealAttributes()
	 * @generated
	 */
	int REAL_ATTRIBUTES = 3;

	/**
	 * The feature id for the '<em><b>Display Unit</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_ATTRIBUTES__DISPLAY_UNIT = 0;

	/**
	 * The feature id for the '<em><b>Max</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_ATTRIBUTES__MAX = 1;

	/**
	 * The feature id for the '<em><b>Min</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_ATTRIBUTES__MIN = 2;

	/**
	 * The feature id for the '<em><b>Quantity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_ATTRIBUTES__QUANTITY = 3;

	/**
	 * The feature id for the '<em><b>Relative Quantity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_ATTRIBUTES__RELATIVE_QUANTITY = 4;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_ATTRIBUTES__UNIT = 5;

	/**
	 * The number of structural features of the '<em>Real Attributes</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_ATTRIBUTES_FEATURE_COUNT = 6;

	/**
	 * The number of operations of the '<em>Real Attributes</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_ATTRIBUTES_OPERATION_COUNT = 0;


	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.fmi.FMIVariables <em>FMI Variables</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>FMI Variables</em>'.
	 * @see com.inchron.realtime.root.model.fmi.FMIVariables
	 * @generated
	 */
	EClass getFMIVariables();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.fmi.IntegerAttributes <em>Integer Attributes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Integer Attributes</em>'.
	 * @see com.inchron.realtime.root.model.fmi.IntegerAttributes
	 * @generated
	 */
	EClass getIntegerAttributes();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.IntegerAttributes#getMax <em>Max</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max</em>'.
	 * @see com.inchron.realtime.root.model.fmi.IntegerAttributes#getMax()
	 * @see #getIntegerAttributes()
	 * @generated
	 */
	EAttribute getIntegerAttributes_Max();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.IntegerAttributes#getMin <em>Min</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Min</em>'.
	 * @see com.inchron.realtime.root.model.fmi.IntegerAttributes#getMin()
	 * @see #getIntegerAttributes()
	 * @generated
	 */
	EAttribute getIntegerAttributes_Min();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.IntegerAttributes#getQuantity <em>Quantity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Quantity</em>'.
	 * @see com.inchron.realtime.root.model.fmi.IntegerAttributes#getQuantity()
	 * @see #getIntegerAttributes()
	 * @generated
	 */
	EAttribute getIntegerAttributes_Quantity();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.fmi.ModelDescription <em>Model Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Description</em>'.
	 * @see com.inchron.realtime.root.model.fmi.ModelDescription
	 * @generated
	 */
	EClass getModelDescription();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.fmi.ModelDescription#getSeed <em>Seed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Seed</em>'.
	 * @see com.inchron.realtime.root.model.fmi.ModelDescription#getSeed()
	 * @see #getModelDescription()
	 * @generated
	 */
	EReference getModelDescription_Seed();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.fmi.ModelDescription#getTime <em>Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Time</em>'.
	 * @see com.inchron.realtime.root.model.fmi.ModelDescription#getTime()
	 * @see #getModelDescription()
	 * @generated
	 */
	EReference getModelDescription_Time();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.fmi.ModelDescription#getTypeDefinitions <em>Type Definitions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Type Definitions</em>'.
	 * @see com.inchron.realtime.root.model.fmi.ModelDescription#getTypeDefinitions()
	 * @see #getModelDescription()
	 * @generated
	 */
	EReference getModelDescription_TypeDefinitions();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.fmi.ModelDescription#getUnitDefinitions <em>Unit Definitions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Unit Definitions</em>'.
	 * @see com.inchron.realtime.root.model.fmi.ModelDescription#getUnitDefinitions()
	 * @see #getModelDescription()
	 * @generated
	 */
	EReference getModelDescription_UnitDefinitions();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.fmi.RealAttributes <em>Real Attributes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Real Attributes</em>'.
	 * @see com.inchron.realtime.root.model.fmi.RealAttributes
	 * @generated
	 */
	EClass getRealAttributes();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.fmi.RealAttributes#getDisplayUnit <em>Display Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Display Unit</em>'.
	 * @see com.inchron.realtime.root.model.fmi.RealAttributes#getDisplayUnit()
	 * @see #getRealAttributes()
	 * @generated
	 */
	EReference getRealAttributes_DisplayUnit();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.RealAttributes#getMax <em>Max</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max</em>'.
	 * @see com.inchron.realtime.root.model.fmi.RealAttributes#getMax()
	 * @see #getRealAttributes()
	 * @generated
	 */
	EAttribute getRealAttributes_Max();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.RealAttributes#getMin <em>Min</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Min</em>'.
	 * @see com.inchron.realtime.root.model.fmi.RealAttributes#getMin()
	 * @see #getRealAttributes()
	 * @generated
	 */
	EAttribute getRealAttributes_Min();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.RealAttributes#getQuantity <em>Quantity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Quantity</em>'.
	 * @see com.inchron.realtime.root.model.fmi.RealAttributes#getQuantity()
	 * @see #getRealAttributes()
	 * @generated
	 */
	EAttribute getRealAttributes_Quantity();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.fmi.RealAttributes#isRelativeQuantity <em>Relative Quantity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Relative Quantity</em>'.
	 * @see com.inchron.realtime.root.model.fmi.RealAttributes#isRelativeQuantity()
	 * @see #getRealAttributes()
	 * @generated
	 */
	EAttribute getRealAttributes_RelativeQuantity();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.fmi.RealAttributes#getUnit <em>Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Unit</em>'.
	 * @see com.inchron.realtime.root.model.fmi.RealAttributes#getUnit()
	 * @see #getRealAttributes()
	 * @generated
	 */
	EReference getRealAttributes_Unit();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	FmiFactory getFmiFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.fmi.impl.FMIVariablesImpl <em>FMI Variables</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.fmi.impl.FMIVariablesImpl
		 * @see com.inchron.realtime.root.model.fmi.impl.FmiPackageImpl#getFMIVariables()
		 * @generated
		 */
		EClass FMI_VARIABLES = eINSTANCE.getFMIVariables();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.fmi.impl.IntegerAttributesImpl <em>Integer Attributes</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.fmi.impl.IntegerAttributesImpl
		 * @see com.inchron.realtime.root.model.fmi.impl.FmiPackageImpl#getIntegerAttributes()
		 * @generated
		 */
		EClass INTEGER_ATTRIBUTES = eINSTANCE.getIntegerAttributes();

		/**
		 * The meta object literal for the '<em><b>Max</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INTEGER_ATTRIBUTES__MAX = eINSTANCE.getIntegerAttributes_Max();

		/**
		 * The meta object literal for the '<em><b>Min</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INTEGER_ATTRIBUTES__MIN = eINSTANCE.getIntegerAttributes_Min();

		/**
		 * The meta object literal for the '<em><b>Quantity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INTEGER_ATTRIBUTES__QUANTITY = eINSTANCE.getIntegerAttributes_Quantity();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.fmi.impl.ModelDescriptionImpl <em>Model Description</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.fmi.impl.ModelDescriptionImpl
		 * @see com.inchron.realtime.root.model.fmi.impl.FmiPackageImpl#getModelDescription()
		 * @generated
		 */
		EClass MODEL_DESCRIPTION = eINSTANCE.getModelDescription();

		/**
		 * The meta object literal for the '<em><b>Seed</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_DESCRIPTION__SEED = eINSTANCE.getModelDescription_Seed();

		/**
		 * The meta object literal for the '<em><b>Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_DESCRIPTION__TIME = eINSTANCE.getModelDescription_Time();

		/**
		 * The meta object literal for the '<em><b>Type Definitions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_DESCRIPTION__TYPE_DEFINITIONS = eINSTANCE.getModelDescription_TypeDefinitions();

		/**
		 * The meta object literal for the '<em><b>Unit Definitions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_DESCRIPTION__UNIT_DEFINITIONS = eINSTANCE.getModelDescription_UnitDefinitions();

		/**
		 * The meta object literal for the '{@link com.inchron.realtime.root.model.fmi.impl.RealAttributesImpl <em>Real Attributes</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.inchron.realtime.root.model.fmi.impl.RealAttributesImpl
		 * @see com.inchron.realtime.root.model.fmi.impl.FmiPackageImpl#getRealAttributes()
		 * @generated
		 */
		EClass REAL_ATTRIBUTES = eINSTANCE.getRealAttributes();

		/**
		 * The meta object literal for the '<em><b>Display Unit</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REAL_ATTRIBUTES__DISPLAY_UNIT = eINSTANCE.getRealAttributes_DisplayUnit();

		/**
		 * The meta object literal for the '<em><b>Max</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REAL_ATTRIBUTES__MAX = eINSTANCE.getRealAttributes_Max();

		/**
		 * The meta object literal for the '<em><b>Min</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REAL_ATTRIBUTES__MIN = eINSTANCE.getRealAttributes_Min();

		/**
		 * The meta object literal for the '<em><b>Quantity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REAL_ATTRIBUTES__QUANTITY = eINSTANCE.getRealAttributes_Quantity();

		/**
		 * The meta object literal for the '<em><b>Relative Quantity</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REAL_ATTRIBUTES__RELATIVE_QUANTITY = eINSTANCE.getRealAttributes_RelativeQuantity();

		/**
		 * The meta object literal for the '<em><b>Unit</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REAL_ATTRIBUTES__UNIT = eINSTANCE.getRealAttributes_Unit();

	}

} //FmiPackage
