/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi;

import com.inchron.realtime.root.model.fmi.type.SimpleType;

import com.inchron.realtime.root.model.fmi.unit.Unit;

import com.inchron.realtime.root.model.fmi.variable.Real;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Model Description</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.fmi.ModelDescription#getSeed <em>Seed</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.ModelDescription#getTime <em>Time</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.ModelDescription#getTypeDefinitions <em>Type Definitions</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.ModelDescription#getUnitDefinitions <em>Unit Definitions</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.fmi.FmiPackage#getModelDescription()
 * @model
 * @generated
 */
public interface ModelDescription extends EObject {
	/**
	 * Returns the value of the '<em><b>Seed</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Seed</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Seed</em>' containment reference.
	 * @see #setSeed(com.inchron.realtime.root.model.fmi.variable.Integer)
	 * @see com.inchron.realtime.root.model.fmi.FmiPackage#getModelDescription_Seed()
	 * @model containment="true" required="true"
	 * @generated
	 */
	com.inchron.realtime.root.model.fmi.variable.Integer getSeed();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.ModelDescription#getSeed <em>Seed</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Seed</em>' containment reference.
	 * @see #getSeed()
	 * @generated
	 */
	void setSeed(com.inchron.realtime.root.model.fmi.variable.Integer value);

	/**
	 * Returns the value of the '<em><b>Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Time</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Time</em>' containment reference.
	 * @see #setTime(Real)
	 * @see com.inchron.realtime.root.model.fmi.FmiPackage#getModelDescription_Time()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Real getTime();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.ModelDescription#getTime <em>Time</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Time</em>' containment reference.
	 * @see #getTime()
	 * @generated
	 */
	void setTime(Real value);

	/**
	 * Returns the value of the '<em><b>Type Definitions</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.fmi.type.SimpleType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type Definitions</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type Definitions</em>' containment reference list.
	 * @see #isSetTypeDefinitions()
	 * @see #unsetTypeDefinitions()
	 * @see com.inchron.realtime.root.model.fmi.FmiPackage#getModelDescription_TypeDefinitions()
	 * @model containment="true" unsettable="true"
	 * @generated
	 */
	EList<SimpleType> getTypeDefinitions();

	/**
	 * Unsets the value of the '{@link com.inchron.realtime.root.model.fmi.ModelDescription#getTypeDefinitions <em>Type Definitions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetTypeDefinitions()
	 * @see #getTypeDefinitions()
	 * @generated
	 */
	void unsetTypeDefinitions();

	/**
	 * Returns whether the value of the '{@link com.inchron.realtime.root.model.fmi.ModelDescription#getTypeDefinitions <em>Type Definitions</em>}' containment reference list is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Type Definitions</em>' containment reference list is set.
	 * @see #unsetTypeDefinitions()
	 * @see #getTypeDefinitions()
	 * @generated
	 */
	boolean isSetTypeDefinitions();

	/**
	 * Returns the value of the '<em><b>Unit Definitions</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.fmi.unit.Unit}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Unit Definitions</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Unit Definitions</em>' containment reference list.
	 * @see #isSetUnitDefinitions()
	 * @see #unsetUnitDefinitions()
	 * @see com.inchron.realtime.root.model.fmi.FmiPackage#getModelDescription_UnitDefinitions()
	 * @model containment="true" unsettable="true"
	 * @generated
	 */
	EList<Unit> getUnitDefinitions();

	/**
	 * Unsets the value of the '{@link com.inchron.realtime.root.model.fmi.ModelDescription#getUnitDefinitions <em>Unit Definitions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetUnitDefinitions()
	 * @see #getUnitDefinitions()
	 * @generated
	 */
	void unsetUnitDefinitions();

	/**
	 * Returns whether the value of the '{@link com.inchron.realtime.root.model.fmi.ModelDescription#getUnitDefinitions <em>Unit Definitions</em>}' containment reference list is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Unit Definitions</em>' containment reference list is set.
	 * @see #unsetUnitDefinitions()
	 * @see #getUnitDefinitions()
	 * @generated
	 */
	boolean isSetUnitDefinitions();

} // ModelDescription
