/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.CallGraph;
import com.inchron.realtime.root.model.GraphEntryBase;
import com.inchron.realtime.root.model.ModelPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Call Graph</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.CallGraphImpl#isEndlessLoop <em>Endless Loop</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CallGraphImpl#getGraphEntries <em>Graph Entries</em>}</li>
 * </ul>
 *
 * @generated
 */
public class CallGraphImpl extends MinimalEObjectImpl.Container implements CallGraph {
	/**
	 * The default value of the '{@link #isEndlessLoop() <em>Endless Loop</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isEndlessLoop()
	 * @generated
	 * @ordered
	 */
	protected static final boolean ENDLESS_LOOP_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isEndlessLoop() <em>Endless Loop</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isEndlessLoop()
	 * @generated
	 * @ordered
	 */
	protected boolean endlessLoop = ENDLESS_LOOP_EDEFAULT;

	/**
	 * The cached value of the '{@link #getGraphEntries() <em>Graph Entries</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGraphEntries()
	 * @generated
	 * @ordered
	 */
	protected EList<GraphEntryBase> graphEntries;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CallGraphImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getCallGraph();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isEndlessLoop() {
		return endlessLoop;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEndlessLoop(boolean newEndlessLoop) {
		boolean oldEndlessLoop = endlessLoop;
		endlessLoop = newEndlessLoop;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CALL_GRAPH__ENDLESS_LOOP, oldEndlessLoop, endlessLoop));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<GraphEntryBase> getGraphEntries() {
		if (graphEntries == null) {
			graphEntries = new EObjectContainmentEList<GraphEntryBase>(GraphEntryBase.class, this, ModelPackage.CALL_GRAPH__GRAPH_ENTRIES);
		}
		return graphEntries;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.CALL_GRAPH__GRAPH_ENTRIES:
				return ((InternalEList<?>)getGraphEntries()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.CALL_GRAPH__ENDLESS_LOOP:
				return isEndlessLoop();
			case ModelPackage.CALL_GRAPH__GRAPH_ENTRIES:
				return getGraphEntries();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.CALL_GRAPH__ENDLESS_LOOP:
				setEndlessLoop((Boolean)newValue);
				return;
			case ModelPackage.CALL_GRAPH__GRAPH_ENTRIES:
				getGraphEntries().clear();
				getGraphEntries().addAll((Collection<? extends GraphEntryBase>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.CALL_GRAPH__ENDLESS_LOOP:
				setEndlessLoop(ENDLESS_LOOP_EDEFAULT);
				return;
			case ModelPackage.CALL_GRAPH__GRAPH_ENTRIES:
				getGraphEntries().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.CALL_GRAPH__ENDLESS_LOOP:
				return endlessLoop != ENDLESS_LOOP_EDEFAULT;
			case ModelPackage.CALL_GRAPH__GRAPH_ENTRIES:
				return graphEntries != null && !graphEntries.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (endlessLoop: ");
		result.append(endlessLoop);
		result.append(')');
		return result.toString();
	}

} //CallGraphImpl
