/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.CallGraph;
import com.inchron.realtime.root.model.Function;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.TraceEvent;
import com.inchron.realtime.root.model.TraceObject;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Function</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.FunctionImpl#getObjectId <em>Object Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.FunctionImpl#getCallGraph <em>Call Graph</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.FunctionImpl#getTraceEvents <em>Trace Events</em>}</li>
 * </ul>
 *
 * @generated
 */
public class FunctionImpl extends ModelObjectImpl implements Function {
	/**
	 * The default value of the '{@link #getObjectId() <em>Object Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObjectId()
	 * @generated
	 * @ordered
	 */
	protected static final int OBJECT_ID_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getObjectId() <em>Object Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObjectId()
	 * @generated
	 * @ordered
	 */
	protected int objectId = OBJECT_ID_EDEFAULT;

	/**
	 * This is true if the Object Id attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean objectIdESet;

	/**
	 * The cached value of the '{@link #getCallGraph() <em>Call Graph</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCallGraph()
	 * @generated
	 * @ordered
	 */
	protected CallGraph callGraph;

	/**
	 * The cached value of the '{@link #getTraceEvents() <em>Trace Events</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTraceEvents()
	 * @generated
	 * @ordered
	 */
	protected EList<TraceEvent> traceEvents;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FunctionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getFunction();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getObjectId() {
		return objectId;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setObjectId(int newObjectId) {
		int oldObjectId = objectId;
		objectId = newObjectId;
		boolean oldObjectIdESet = objectIdESet;
		objectIdESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.FUNCTION__OBJECT_ID, oldObjectId, objectId, !oldObjectIdESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetObjectId() {
		int oldObjectId = objectId;
		boolean oldObjectIdESet = objectIdESet;
		objectId = OBJECT_ID_EDEFAULT;
		objectIdESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, ModelPackage.FUNCTION__OBJECT_ID, oldObjectId, OBJECT_ID_EDEFAULT, oldObjectIdESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetObjectId() {
		return objectIdESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallGraph getCallGraph() {
		return callGraph;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCallGraph(CallGraph newCallGraph, NotificationChain msgs) {
		CallGraph oldCallGraph = callGraph;
		callGraph = newCallGraph;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.FUNCTION__CALL_GRAPH, oldCallGraph, newCallGraph);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCallGraph(CallGraph newCallGraph) {
		if (newCallGraph != callGraph) {
			NotificationChain msgs = null;
			if (callGraph != null)
				msgs = ((InternalEObject)callGraph).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.FUNCTION__CALL_GRAPH, null, msgs);
			if (newCallGraph != null)
				msgs = ((InternalEObject)newCallGraph).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.FUNCTION__CALL_GRAPH, null, msgs);
			msgs = basicSetCallGraph(newCallGraph, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.FUNCTION__CALL_GRAPH, newCallGraph, newCallGraph));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<TraceEvent> getTraceEvents() {
		if (traceEvents == null) {
			traceEvents = new EObjectContainmentEList<TraceEvent>(TraceEvent.class, this, ModelPackage.FUNCTION__TRACE_EVENTS);
		}
		return traceEvents;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.FUNCTION__CALL_GRAPH:
				return basicSetCallGraph(null, msgs);
			case ModelPackage.FUNCTION__TRACE_EVENTS:
				return ((InternalEList<?>)getTraceEvents()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.FUNCTION__OBJECT_ID:
				return getObjectId();
			case ModelPackage.FUNCTION__CALL_GRAPH:
				return getCallGraph();
			case ModelPackage.FUNCTION__TRACE_EVENTS:
				return getTraceEvents();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.FUNCTION__OBJECT_ID:
				setObjectId((Integer)newValue);
				return;
			case ModelPackage.FUNCTION__CALL_GRAPH:
				setCallGraph((CallGraph)newValue);
				return;
			case ModelPackage.FUNCTION__TRACE_EVENTS:
				getTraceEvents().clear();
				getTraceEvents().addAll((Collection<? extends TraceEvent>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.FUNCTION__OBJECT_ID:
				unsetObjectId();
				return;
			case ModelPackage.FUNCTION__CALL_GRAPH:
				setCallGraph((CallGraph)null);
				return;
			case ModelPackage.FUNCTION__TRACE_EVENTS:
				getTraceEvents().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.FUNCTION__OBJECT_ID:
				return isSetObjectId();
			case ModelPackage.FUNCTION__CALL_GRAPH:
				return callGraph != null;
			case ModelPackage.FUNCTION__TRACE_EVENTS:
				return traceEvents != null && !traceEvents.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == TraceObject.class) {
			switch (derivedFeatureID) {
				case ModelPackage.FUNCTION__OBJECT_ID: return ModelPackage.TRACE_OBJECT__OBJECT_ID;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == TraceObject.class) {
			switch (baseFeatureID) {
				case ModelPackage.TRACE_OBJECT__OBJECT_ID: return ModelPackage.FUNCTION__OBJECT_ID;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (objectId: ");
		if (objectIdESet) result.append(objectId); else result.append("<unset>");
		result.append(')');
		return result.toString();
	}

} //FunctionImpl
