/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.ModeSwitch;
import com.inchron.realtime.root.model.ModeSwitchDefault;
import com.inchron.realtime.root.model.ModeSwitchEntry;
import com.inchron.realtime.root.model.ModelPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Mode Switch</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.ModeSwitchImpl#getDefaultEntry <em>Default Entry</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ModeSwitchImpl#getEntries <em>Entries</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ModeSwitchImpl#isEvaluateConditionsOnEntry <em>Evaluate Conditions On Entry</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ModeSwitchImpl extends GraphEntryBaseImpl implements ModeSwitch {
	/**
	 * The cached value of the '{@link #getDefaultEntry() <em>Default Entry</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDefaultEntry()
	 * @generated
	 * @ordered
	 */
	protected ModeSwitchDefault defaultEntry;

	/**
	 * The cached value of the '{@link #getEntries() <em>Entries</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEntries()
	 * @generated
	 * @ordered
	 */
	protected EList<ModeSwitchEntry> entries;

	/**
	 * The default value of the '{@link #isEvaluateConditionsOnEntry() <em>Evaluate Conditions On Entry</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isEvaluateConditionsOnEntry()
	 * @generated
	 * @ordered
	 */
	protected static final boolean EVALUATE_CONDITIONS_ON_ENTRY_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isEvaluateConditionsOnEntry() <em>Evaluate Conditions On Entry</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isEvaluateConditionsOnEntry()
	 * @generated
	 * @ordered
	 */
	protected boolean evaluateConditionsOnEntry = EVALUATE_CONDITIONS_ON_ENTRY_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModeSwitchImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getModeSwitch();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModeSwitchDefault getDefaultEntry() {
		return defaultEntry;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDefaultEntry(ModeSwitchDefault newDefaultEntry, NotificationChain msgs) {
		ModeSwitchDefault oldDefaultEntry = defaultEntry;
		defaultEntry = newDefaultEntry;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.MODE_SWITCH__DEFAULT_ENTRY, oldDefaultEntry, newDefaultEntry);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDefaultEntry(ModeSwitchDefault newDefaultEntry) {
		if (newDefaultEntry != defaultEntry) {
			NotificationChain msgs = null;
			if (defaultEntry != null)
				msgs = ((InternalEObject)defaultEntry).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.MODE_SWITCH__DEFAULT_ENTRY, null, msgs);
			if (newDefaultEntry != null)
				msgs = ((InternalEObject)newDefaultEntry).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.MODE_SWITCH__DEFAULT_ENTRY, null, msgs);
			msgs = basicSetDefaultEntry(newDefaultEntry, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.MODE_SWITCH__DEFAULT_ENTRY, newDefaultEntry, newDefaultEntry));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ModeSwitchEntry> getEntries() {
		if (entries == null) {
			entries = new EObjectContainmentEList<ModeSwitchEntry>(ModeSwitchEntry.class, this, ModelPackage.MODE_SWITCH__ENTRIES);
		}
		return entries;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isEvaluateConditionsOnEntry() {
		return evaluateConditionsOnEntry;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEvaluateConditionsOnEntry(boolean newEvaluateConditionsOnEntry) {
		boolean oldEvaluateConditionsOnEntry = evaluateConditionsOnEntry;
		evaluateConditionsOnEntry = newEvaluateConditionsOnEntry;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.MODE_SWITCH__EVALUATE_CONDITIONS_ON_ENTRY, oldEvaluateConditionsOnEntry, evaluateConditionsOnEntry));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.MODE_SWITCH__DEFAULT_ENTRY:
				return basicSetDefaultEntry(null, msgs);
			case ModelPackage.MODE_SWITCH__ENTRIES:
				return ((InternalEList<?>)getEntries()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.MODE_SWITCH__DEFAULT_ENTRY:
				return getDefaultEntry();
			case ModelPackage.MODE_SWITCH__ENTRIES:
				return getEntries();
			case ModelPackage.MODE_SWITCH__EVALUATE_CONDITIONS_ON_ENTRY:
				return isEvaluateConditionsOnEntry();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.MODE_SWITCH__DEFAULT_ENTRY:
				setDefaultEntry((ModeSwitchDefault)newValue);
				return;
			case ModelPackage.MODE_SWITCH__ENTRIES:
				getEntries().clear();
				getEntries().addAll((Collection<? extends ModeSwitchEntry>)newValue);
				return;
			case ModelPackage.MODE_SWITCH__EVALUATE_CONDITIONS_ON_ENTRY:
				setEvaluateConditionsOnEntry((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.MODE_SWITCH__DEFAULT_ENTRY:
				setDefaultEntry((ModeSwitchDefault)null);
				return;
			case ModelPackage.MODE_SWITCH__ENTRIES:
				getEntries().clear();
				return;
			case ModelPackage.MODE_SWITCH__EVALUATE_CONDITIONS_ON_ENTRY:
				setEvaluateConditionsOnEntry(EVALUATE_CONDITIONS_ON_ENTRY_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.MODE_SWITCH__DEFAULT_ENTRY:
				return defaultEntry != null;
			case ModelPackage.MODE_SWITCH__ENTRIES:
				return entries != null && !entries.isEmpty();
			case ModelPackage.MODE_SWITCH__EVALUATE_CONDITIONS_ON_ENTRY:
				return evaluateConditionsOnEntry != EVALUATE_CONDITIONS_ON_ENTRY_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (evaluateConditionsOnEntry: ");
		result.append(evaluateConditionsOnEntry);
		result.append(')');
		return result.toString();
	}

} //ModeSwitchImpl
