/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.Time;
import com.inchron.realtime.root.model.TimeInterval;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Time Interval</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.TimeIntervalImpl#getLowerLimit <em>Lower Limit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.TimeIntervalImpl#getUpperLimit <em>Upper Limit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.TimeIntervalImpl#isLowerLimitIncluded <em>Lower Limit Included</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.TimeIntervalImpl#isUpperLimitIncluded <em>Upper Limit Included</em>}</li>
 * </ul>
 *
 * @generated
 */
public class TimeIntervalImpl extends MinimalEObjectImpl.Container implements TimeInterval {
	/**
	 * The cached value of the '{@link #getLowerLimit() <em>Lower Limit</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLowerLimit()
	 * @generated
	 * @ordered
	 */
	protected Time lowerLimit;

	/**
	 * The cached value of the '{@link #getUpperLimit() <em>Upper Limit</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUpperLimit()
	 * @generated
	 * @ordered
	 */
	protected Time upperLimit;

	/**
	 * The default value of the '{@link #isLowerLimitIncluded() <em>Lower Limit Included</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isLowerLimitIncluded()
	 * @generated
	 * @ordered
	 */
	protected static final boolean LOWER_LIMIT_INCLUDED_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isLowerLimitIncluded() <em>Lower Limit Included</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isLowerLimitIncluded()
	 * @generated
	 * @ordered
	 */
	protected boolean lowerLimitIncluded = LOWER_LIMIT_INCLUDED_EDEFAULT;

	/**
	 * The default value of the '{@link #isUpperLimitIncluded() <em>Upper Limit Included</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isUpperLimitIncluded()
	 * @generated
	 * @ordered
	 */
	protected static final boolean UPPER_LIMIT_INCLUDED_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isUpperLimitIncluded() <em>Upper Limit Included</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isUpperLimitIncluded()
	 * @generated
	 * @ordered
	 */
	protected boolean upperLimitIncluded = UPPER_LIMIT_INCLUDED_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TimeIntervalImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getTimeInterval();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getLowerLimit() {
		return lowerLimit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetLowerLimit(Time newLowerLimit, NotificationChain msgs) {
		Time oldLowerLimit = lowerLimit;
		lowerLimit = newLowerLimit;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_INTERVAL__LOWER_LIMIT, oldLowerLimit, newLowerLimit);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLowerLimit(Time newLowerLimit) {
		if (newLowerLimit != lowerLimit) {
			NotificationChain msgs = null;
			if (lowerLimit != null)
				msgs = ((InternalEObject)lowerLimit).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.TIME_INTERVAL__LOWER_LIMIT, null, msgs);
			if (newLowerLimit != null)
				msgs = ((InternalEObject)newLowerLimit).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.TIME_INTERVAL__LOWER_LIMIT, null, msgs);
			msgs = basicSetLowerLimit(newLowerLimit, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_INTERVAL__LOWER_LIMIT, newLowerLimit, newLowerLimit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getUpperLimit() {
		return upperLimit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetUpperLimit(Time newUpperLimit, NotificationChain msgs) {
		Time oldUpperLimit = upperLimit;
		upperLimit = newUpperLimit;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_INTERVAL__UPPER_LIMIT, oldUpperLimit, newUpperLimit);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUpperLimit(Time newUpperLimit) {
		if (newUpperLimit != upperLimit) {
			NotificationChain msgs = null;
			if (upperLimit != null)
				msgs = ((InternalEObject)upperLimit).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.TIME_INTERVAL__UPPER_LIMIT, null, msgs);
			if (newUpperLimit != null)
				msgs = ((InternalEObject)newUpperLimit).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.TIME_INTERVAL__UPPER_LIMIT, null, msgs);
			msgs = basicSetUpperLimit(newUpperLimit, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_INTERVAL__UPPER_LIMIT, newUpperLimit, newUpperLimit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isLowerLimitIncluded() {
		return lowerLimitIncluded;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLowerLimitIncluded(boolean newLowerLimitIncluded) {
		boolean oldLowerLimitIncluded = lowerLimitIncluded;
		lowerLimitIncluded = newLowerLimitIncluded;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_INTERVAL__LOWER_LIMIT_INCLUDED, oldLowerLimitIncluded, lowerLimitIncluded));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isUpperLimitIncluded() {
		return upperLimitIncluded;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUpperLimitIncluded(boolean newUpperLimitIncluded) {
		boolean oldUpperLimitIncluded = upperLimitIncluded;
		upperLimitIncluded = newUpperLimitIncluded;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.TIME_INTERVAL__UPPER_LIMIT_INCLUDED, oldUpperLimitIncluded, upperLimitIncluded));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.TIME_INTERVAL__LOWER_LIMIT:
				return basicSetLowerLimit(null, msgs);
			case ModelPackage.TIME_INTERVAL__UPPER_LIMIT:
				return basicSetUpperLimit(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.TIME_INTERVAL__LOWER_LIMIT:
				return getLowerLimit();
			case ModelPackage.TIME_INTERVAL__UPPER_LIMIT:
				return getUpperLimit();
			case ModelPackage.TIME_INTERVAL__LOWER_LIMIT_INCLUDED:
				return isLowerLimitIncluded();
			case ModelPackage.TIME_INTERVAL__UPPER_LIMIT_INCLUDED:
				return isUpperLimitIncluded();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.TIME_INTERVAL__LOWER_LIMIT:
				setLowerLimit((Time)newValue);
				return;
			case ModelPackage.TIME_INTERVAL__UPPER_LIMIT:
				setUpperLimit((Time)newValue);
				return;
			case ModelPackage.TIME_INTERVAL__LOWER_LIMIT_INCLUDED:
				setLowerLimitIncluded((Boolean)newValue);
				return;
			case ModelPackage.TIME_INTERVAL__UPPER_LIMIT_INCLUDED:
				setUpperLimitIncluded((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.TIME_INTERVAL__LOWER_LIMIT:
				setLowerLimit((Time)null);
				return;
			case ModelPackage.TIME_INTERVAL__UPPER_LIMIT:
				setUpperLimit((Time)null);
				return;
			case ModelPackage.TIME_INTERVAL__LOWER_LIMIT_INCLUDED:
				setLowerLimitIncluded(LOWER_LIMIT_INCLUDED_EDEFAULT);
				return;
			case ModelPackage.TIME_INTERVAL__UPPER_LIMIT_INCLUDED:
				setUpperLimitIncluded(UPPER_LIMIT_INCLUDED_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.TIME_INTERVAL__LOWER_LIMIT:
				return lowerLimit != null;
			case ModelPackage.TIME_INTERVAL__UPPER_LIMIT:
				return upperLimit != null;
			case ModelPackage.TIME_INTERVAL__LOWER_LIMIT_INCLUDED:
				return lowerLimitIncluded != LOWER_LIMIT_INCLUDED_EDEFAULT;
			case ModelPackage.TIME_INTERVAL__UPPER_LIMIT_INCLUDED:
				return upperLimitIncluded != UPPER_LIMIT_INCLUDED_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (lowerLimitIncluded: ");
		result.append(lowerLimitIncluded);
		result.append(", upperLimitIncluded: ");
		result.append(upperLimitIncluded);
		result.append(')');
		return result.toString();
	}

} //TimeIntervalImpl
