/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.memory;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Explicit Data Access</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.memory.ExplicitDataAccess#getDataObject <em>Data Object</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.ExplicitDataAccess#getRatio <em>Ratio</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getExplicitDataAccess()
 * @model
 * @generated
 */
public interface ExplicitDataAccess extends DataAccess {
	/**
	 * Returns the value of the '<em><b>Data Object</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Data Object</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Data Object</em>' reference.
	 * @see #setDataObject(DataObject)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getExplicitDataAccess_DataObject()
	 * @model
	 * @generated
	 */
	DataObject getDataObject();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.ExplicitDataAccess#getDataObject <em>Data Object</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Data Object</em>' reference.
	 * @see #getDataObject()
	 * @generated
	 */
	void setDataObject(DataObject value);

	/**
	 * Returns the value of the '<em><b>Ratio</b></em>' attribute.
	 * The default value is <code>"1.0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Ratio</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Ratio</em>' attribute.
	 * @see #setRatio(float)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getExplicitDataAccess_Ratio()
	 * @model default="1.0" required="true"
	 * @generated
	 */
	float getRatio();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.ExplicitDataAccess#getRatio <em>Ratio</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ratio</em>' attribute.
	 * @see #getRatio()
	 * @generated
	 */
	void setRatio(float value);

} // ExplicitDataAccess
