/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.memory;

import com.inchron.realtime.root.model.ModelObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Initiator Port</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.memory.InitiatorPort#getPriority <em>Priority</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.InitiatorPort#getResponder <em>Responder</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getInitiatorPort()
 * @model
 * @generated
 */
public interface InitiatorPort extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Priority</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Priority</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Priority</em>' attribute.
	 * @see #setPriority(int)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getInitiatorPort_Priority()
	 * @model default="0"
	 * @generated
	 */
	int getPriority();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.InitiatorPort#getPriority <em>Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Priority</em>' attribute.
	 * @see #getPriority()
	 * @generated
	 */
	void setPriority(int value);

	/**
	 * Returns the value of the '<em><b>Responder</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link com.inchron.realtime.root.model.memory.ResponderPort#getInitiator <em>Initiator</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Responder</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Responder</em>' reference.
	 * @see #setResponder(ResponderPort)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getInitiatorPort_Responder()
	 * @see com.inchron.realtime.root.model.memory.ResponderPort#getInitiator
	 * @model opposite="initiator"
	 * @generated
	 */
	ResponderPort getResponder();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.InitiatorPort#getResponder <em>Responder</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Responder</em>' reference.
	 * @see #getResponder()
	 * @generated
	 */
	void setResponder(ResponderPort value);

} // InitiatorPort
