/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.memory;

import com.inchron.realtime.root.model.ClockUser;
import com.inchron.realtime.root.model.ModelObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Memory</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.memory.Memory#getBitWidth <em>Bit Width</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.Memory#getSize <em>Size</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.Memory#getType <em>Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.Memory#getPrescaler <em>Prescaler</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.Memory#getConnectedMaster <em>Connected Master</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getMemory()
 * @model
 * @generated
 */
public interface Memory extends ModelObject, ClockUser {
	/**
	 * Returns the value of the '<em><b>Bit Width</b></em>' attribute.
	 * The default value is <code>"32"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Bit Width</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Bit Width</em>' attribute.
	 * @see #setBitWidth(int)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getMemory_BitWidth()
	 * @model default="32"
	 * @generated
	 */
	int getBitWidth();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.Memory#getBitWidth <em>Bit Width</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Bit Width</em>' attribute.
	 * @see #getBitWidth()
	 * @generated
	 */
	void setBitWidth(int value);

	/**
	 * Returns the value of the '<em><b>Size</b></em>' attribute.
	 * The default value is <code>"262144"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Size</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Size</em>' attribute.
	 * @see #setSize(int)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getMemory_Size()
	 * @model default="262144"
	 * @generated
	 */
	int getSize();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.Memory#getSize <em>Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Size</em>' attribute.
	 * @see #getSize()
	 * @generated
	 */
	void setSize(int value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The default value is <code>"SRAM"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.memory.MemoryType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.memory.MemoryType
	 * @see #setType(MemoryType)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getMemory_Type()
	 * @model default="SRAM"
	 * @generated
	 */
	MemoryType getType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.Memory#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.memory.MemoryType
	 * @see #getType()
	 * @generated
	 */
	void setType(MemoryType value);

	/**
	 * Returns the value of the '<em><b>Prescaler</b></em>' attribute.
	 * The default value is <code>"1.0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Prescaler</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Prescaler</em>' attribute.
	 * @see #setPrescaler(double)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getMemory_Prescaler()
	 * @model default="1.0"
	 * @generated
	 */
	double getPrescaler();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.Memory#getPrescaler <em>Prescaler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Prescaler</em>' attribute.
	 * @see #getPrescaler()
	 * @generated
	 */
	void setPrescaler(double value);

	/**
	 * Returns the value of the '<em><b>Connected Master</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Connected Master</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Connected Master</em>' containment reference.
	 * @see #setConnectedMaster(ResponderPort)
	 * @see com.inchron.realtime.root.model.memory.MemoryPackage#getMemory_ConnectedMaster()
	 * @model containment="true"
	 * @generated
	 */
	ResponderPort getConnectedMaster();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.memory.Memory#getConnectedMaster <em>Connected Master</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Connected Master</em>' containment reference.
	 * @see #getConnectedMaster()
	 * @generated
	 */
	void setConnectedMaster(ResponderPort value);

} // Memory
