/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;

import com.inchron.realtime.root.model.ModelObject;
import com.inchron.realtime.root.model.TraceEvent;
import com.inchron.realtime.root.model.TraceObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Abstract Peripheral</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AbstractPeripheral#getExactness <em>Exactness</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AbstractPeripheral#getEvents <em>Events</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AbstractPeripheral#getPorts <em>Ports</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAbstractPeripheral()
 * @model abstract="true"
 * @generated
 */
public interface AbstractPeripheral extends ModelObject, TraceObject {
	/**
	 * Returns the value of the '<em><b>Exactness</b></em>' attribute.
	 * The default value is <code>"10"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Exactness</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Exactness</em>' attribute.
	 * @see #setExactness(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAbstractPeripheral_Exactness()
	 * @model default="10" required="true"
	 * @generated
	 */
	int getExactness();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AbstractPeripheral#getExactness <em>Exactness</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Exactness</em>' attribute.
	 * @see #getExactness()
	 * @generated
	 */
	void setExactness(int value);

	/**
	 * Returns the value of the '<em><b>Events</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.TraceEvent}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Events</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Events</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAbstractPeripheral_Events()
	 * @model containment="true"
	 * @generated
	 */
	EList<TraceEvent> getEvents();

	/**
	 * Returns the value of the '<em><b>Ports</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.peripheral.AbstractPort}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Ports</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Ports</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAbstractPeripheral_Ports()
	 * @model containment="true" required="true" ordered="false"
	 * @generated
	 */
	EList<AbstractPort> getPorts();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	boolean isCompatible(AbstractPeripheral other);

} // AbstractPeripheral
