/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;

import com.inchron.realtime.root.model.AddressRange;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Peripheral</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.Peripheral#getAddressRange <em>Address Range</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getPeripheral()
 * @model abstract="true"
 * @generated
 */
public interface Peripheral extends AbstractPeripheral {
	/**
	 * Returns the value of the '<em><b>Address Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Address Range</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Address Range</em>' containment reference.
	 * @see #setAddressRange(AddressRange)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getPeripheral_AddressRange()
	 * @model containment="true" required="true" ordered="false"
	 * @generated
	 */
	AddressRange getAddressRange();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.Peripheral#getAddressRange <em>Address Range</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Address Range</em>' containment reference.
	 * @see #getAddressRange()
	 * @generated
	 */
	void setAddressRange(AddressRange value);

} // Peripheral
