/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral.impl;

import com.inchron.realtime.root.model.peripheral.AFDXEthernet;
import com.inchron.realtime.root.model.peripheral.AFDXPort;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>AFDX Ethernet</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AFDXEthernetImpl#getNetworkId <em>Network Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AFDXEthernetImpl#getEquipmentId <em>Equipment Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AFDXEthernetImpl#getPartitionId <em>Partition Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AFDXEthernetImpl#getInterfaceId1 <em>Interface Id1</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AFDXEthernetImpl#getMac1 <em>Mac1</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AFDXEthernetImpl#getInterfaceId2 <em>Interface Id2</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AFDXEthernetImpl#getMac2 <em>Mac2</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.AFDXEthernetImpl#getAfdxPorts <em>Afdx Ports</em>}</li>
 * </ul>
 *
 * @generated
 */
public class AFDXEthernetImpl extends AbstractEthernetImpl implements AFDXEthernet {
	/**
	 * The default value of the '{@link #getNetworkId() <em>Network Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNetworkId()
	 * @generated
	 * @ordered
	 */
	protected static final int NETWORK_ID_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getNetworkId() <em>Network Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNetworkId()
	 * @generated
	 * @ordered
	 */
	protected int networkId = NETWORK_ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getEquipmentId() <em>Equipment Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEquipmentId()
	 * @generated
	 * @ordered
	 */
	protected static final int EQUIPMENT_ID_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getEquipmentId() <em>Equipment Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEquipmentId()
	 * @generated
	 * @ordered
	 */
	protected int equipmentId = EQUIPMENT_ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getPartitionId() <em>Partition Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPartitionId()
	 * @generated
	 * @ordered
	 */
	protected static final int PARTITION_ID_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getPartitionId() <em>Partition Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPartitionId()
	 * @generated
	 * @ordered
	 */
	protected int partitionId = PARTITION_ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getInterfaceId1() <em>Interface Id1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterfaceId1()
	 * @generated
	 * @ordered
	 */
	protected static final int INTERFACE_ID1_EDEFAULT = 1;

	/**
	 * The cached value of the '{@link #getInterfaceId1() <em>Interface Id1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterfaceId1()
	 * @generated
	 * @ordered
	 */
	protected int interfaceId1 = INTERFACE_ID1_EDEFAULT;

	/**
	 * The default value of the '{@link #getMac1() <em>Mac1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMac1()
	 * @generated
	 * @ordered
	 */
	protected static final String MAC1_EDEFAULT = "00:00:00:00:00:00";

	/**
	 * The cached value of the '{@link #getMac1() <em>Mac1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMac1()
	 * @generated
	 * @ordered
	 */
	protected String mac1 = MAC1_EDEFAULT;

	/**
	 * The default value of the '{@link #getInterfaceId2() <em>Interface Id2</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterfaceId2()
	 * @generated
	 * @ordered
	 */
	protected static final int INTERFACE_ID2_EDEFAULT = 2;

	/**
	 * The cached value of the '{@link #getInterfaceId2() <em>Interface Id2</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterfaceId2()
	 * @generated
	 * @ordered
	 */
	protected int interfaceId2 = INTERFACE_ID2_EDEFAULT;

	/**
	 * The default value of the '{@link #getMac2() <em>Mac2</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMac2()
	 * @generated
	 * @ordered
	 */
	protected static final String MAC2_EDEFAULT = "00:00:00:00:00:01";

	/**
	 * The cached value of the '{@link #getMac2() <em>Mac2</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMac2()
	 * @generated
	 * @ordered
	 */
	protected String mac2 = MAC2_EDEFAULT;

	/**
	 * The cached value of the '{@link #getAfdxPorts() <em>Afdx Ports</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAfdxPorts()
	 * @generated
	 * @ordered
	 */
	protected EList<AFDXPort> afdxPorts;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AFDXEthernetImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PeripheralPackage.Literals.AFDX_ETHERNET;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getNetworkId() {
		return networkId;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNetworkId(int newNetworkId) {
		int oldNetworkId = networkId;
		networkId = newNetworkId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.AFDX_ETHERNET__NETWORK_ID, oldNetworkId, networkId));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getEquipmentId() {
		return equipmentId;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEquipmentId(int newEquipmentId) {
		int oldEquipmentId = equipmentId;
		equipmentId = newEquipmentId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.AFDX_ETHERNET__EQUIPMENT_ID, oldEquipmentId, equipmentId));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getPartitionId() {
		return partitionId;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPartitionId(int newPartitionId) {
		int oldPartitionId = partitionId;
		partitionId = newPartitionId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.AFDX_ETHERNET__PARTITION_ID, oldPartitionId, partitionId));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getInterfaceId1() {
		return interfaceId1;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInterfaceId1(int newInterfaceId1) {
		int oldInterfaceId1 = interfaceId1;
		interfaceId1 = newInterfaceId1;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.AFDX_ETHERNET__INTERFACE_ID1, oldInterfaceId1, interfaceId1));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getMac1() {
		return mac1;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMac1(String newMac1) {
		String oldMac1 = mac1;
		mac1 = newMac1;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.AFDX_ETHERNET__MAC1, oldMac1, mac1));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getInterfaceId2() {
		return interfaceId2;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInterfaceId2(int newInterfaceId2) {
		int oldInterfaceId2 = interfaceId2;
		interfaceId2 = newInterfaceId2;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.AFDX_ETHERNET__INTERFACE_ID2, oldInterfaceId2, interfaceId2));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getMac2() {
		return mac2;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMac2(String newMac2) {
		String oldMac2 = mac2;
		mac2 = newMac2;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.AFDX_ETHERNET__MAC2, oldMac2, mac2));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<AFDXPort> getAfdxPorts() {
		if (afdxPorts == null) {
			afdxPorts = new EObjectContainmentEList<AFDXPort>(AFDXPort.class, this, PeripheralPackage.AFDX_ETHERNET__AFDX_PORTS);
		}
		return afdxPorts;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case PeripheralPackage.AFDX_ETHERNET__AFDX_PORTS:
				return ((InternalEList<?>)getAfdxPorts()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PeripheralPackage.AFDX_ETHERNET__NETWORK_ID:
				return getNetworkId();
			case PeripheralPackage.AFDX_ETHERNET__EQUIPMENT_ID:
				return getEquipmentId();
			case PeripheralPackage.AFDX_ETHERNET__PARTITION_ID:
				return getPartitionId();
			case PeripheralPackage.AFDX_ETHERNET__INTERFACE_ID1:
				return getInterfaceId1();
			case PeripheralPackage.AFDX_ETHERNET__MAC1:
				return getMac1();
			case PeripheralPackage.AFDX_ETHERNET__INTERFACE_ID2:
				return getInterfaceId2();
			case PeripheralPackage.AFDX_ETHERNET__MAC2:
				return getMac2();
			case PeripheralPackage.AFDX_ETHERNET__AFDX_PORTS:
				return getAfdxPorts();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PeripheralPackage.AFDX_ETHERNET__NETWORK_ID:
				setNetworkId((Integer)newValue);
				return;
			case PeripheralPackage.AFDX_ETHERNET__EQUIPMENT_ID:
				setEquipmentId((Integer)newValue);
				return;
			case PeripheralPackage.AFDX_ETHERNET__PARTITION_ID:
				setPartitionId((Integer)newValue);
				return;
			case PeripheralPackage.AFDX_ETHERNET__INTERFACE_ID1:
				setInterfaceId1((Integer)newValue);
				return;
			case PeripheralPackage.AFDX_ETHERNET__MAC1:
				setMac1((String)newValue);
				return;
			case PeripheralPackage.AFDX_ETHERNET__INTERFACE_ID2:
				setInterfaceId2((Integer)newValue);
				return;
			case PeripheralPackage.AFDX_ETHERNET__MAC2:
				setMac2((String)newValue);
				return;
			case PeripheralPackage.AFDX_ETHERNET__AFDX_PORTS:
				getAfdxPorts().clear();
				getAfdxPorts().addAll((Collection<? extends AFDXPort>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PeripheralPackage.AFDX_ETHERNET__NETWORK_ID:
				setNetworkId(NETWORK_ID_EDEFAULT);
				return;
			case PeripheralPackage.AFDX_ETHERNET__EQUIPMENT_ID:
				setEquipmentId(EQUIPMENT_ID_EDEFAULT);
				return;
			case PeripheralPackage.AFDX_ETHERNET__PARTITION_ID:
				setPartitionId(PARTITION_ID_EDEFAULT);
				return;
			case PeripheralPackage.AFDX_ETHERNET__INTERFACE_ID1:
				setInterfaceId1(INTERFACE_ID1_EDEFAULT);
				return;
			case PeripheralPackage.AFDX_ETHERNET__MAC1:
				setMac1(MAC1_EDEFAULT);
				return;
			case PeripheralPackage.AFDX_ETHERNET__INTERFACE_ID2:
				setInterfaceId2(INTERFACE_ID2_EDEFAULT);
				return;
			case PeripheralPackage.AFDX_ETHERNET__MAC2:
				setMac2(MAC2_EDEFAULT);
				return;
			case PeripheralPackage.AFDX_ETHERNET__AFDX_PORTS:
				getAfdxPorts().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PeripheralPackage.AFDX_ETHERNET__NETWORK_ID:
				return networkId != NETWORK_ID_EDEFAULT;
			case PeripheralPackage.AFDX_ETHERNET__EQUIPMENT_ID:
				return equipmentId != EQUIPMENT_ID_EDEFAULT;
			case PeripheralPackage.AFDX_ETHERNET__PARTITION_ID:
				return partitionId != PARTITION_ID_EDEFAULT;
			case PeripheralPackage.AFDX_ETHERNET__INTERFACE_ID1:
				return interfaceId1 != INTERFACE_ID1_EDEFAULT;
			case PeripheralPackage.AFDX_ETHERNET__MAC1:
				return MAC1_EDEFAULT == null ? mac1 != null : !MAC1_EDEFAULT.equals(mac1);
			case PeripheralPackage.AFDX_ETHERNET__INTERFACE_ID2:
				return interfaceId2 != INTERFACE_ID2_EDEFAULT;
			case PeripheralPackage.AFDX_ETHERNET__MAC2:
				return MAC2_EDEFAULT == null ? mac2 != null : !MAC2_EDEFAULT.equals(mac2);
			case PeripheralPackage.AFDX_ETHERNET__AFDX_PORTS:
				return afdxPorts != null && !afdxPorts.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (networkId: ");
		result.append(networkId);
		result.append(", equipmentId: ");
		result.append(equipmentId);
		result.append(", partitionId: ");
		result.append(partitionId);
		result.append(", interfaceId1: ");
		result.append(interfaceId1);
		result.append(", mac1: ");
		result.append(mac1);
		result.append(", interfaceId2: ");
		result.append(interfaceId2);
		result.append(", mac2: ");
		result.append(mac2);
		result.append(')');
		return result.toString();
	}

} //AFDXEthernetImpl
