/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Event Chain Strategy</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventChainStrategy()
 * @model
 * @generated
 */
public enum EventChainStrategy implements Enumerator {
	/**
	 * The '<em><b>First First</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FIRST_FIRST_VALUE
	 * @generated
	 * @ordered
	 */
	FIRST_FIRST(0, "FirstFirst", "FirstFirst"),

	/**
	 * The '<em><b>First Last</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FIRST_LAST_VALUE
	 * @generated
	 * @ordered
	 */
	FIRST_LAST(1, "FirstLast", "FirstLast"),

	/**
	 * The '<em><b>Last Last</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #LAST_LAST_VALUE
	 * @generated
	 * @ordered
	 */
	LAST_LAST(2, "LastLast", "LastLast"),

	/**
	 * The '<em><b>Multi First</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MULTI_FIRST_VALUE
	 * @generated
	 * @ordered
	 */
	MULTI_FIRST(3, "MultiFirst", "MultiFirst"),

	/**
	 * The '<em><b>Multi Last</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MULTI_LAST_VALUE
	 * @generated
	 * @ordered
	 */
	MULTI_LAST(4, "MultiLast", "MultiLast"),

	/**
	 * The '<em><b>Multi Backward Preceding</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MULTI_BACKWARD_PRECEDING_VALUE
	 * @generated
	 * @ordered
	 */
	MULTI_BACKWARD_PRECEDING(5, "MultiBackwardPreceding", "MultiBackwardPreceding"),

	/**
	 * The '<em><b>Multi Backward Earliest</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MULTI_BACKWARD_EARLIEST_VALUE
	 * @generated
	 * @ordered
	 */
	MULTI_BACKWARD_EARLIEST(6, "MultiBackwardEarliest", "MultiBackwardEarliest");

	/**
	 * The '<em><b>First First</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>First First</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #FIRST_FIRST
	 * @model name="FirstFirst"
	 * @generated
	 * @ordered
	 */
	public static final int FIRST_FIRST_VALUE = 0;

	/**
	 * The '<em><b>First Last</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>First Last</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #FIRST_LAST
	 * @model name="FirstLast"
	 * @generated
	 * @ordered
	 */
	public static final int FIRST_LAST_VALUE = 1;

	/**
	 * The '<em><b>Last Last</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Last Last</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #LAST_LAST
	 * @model name="LastLast"
	 * @generated
	 * @ordered
	 */
	public static final int LAST_LAST_VALUE = 2;

	/**
	 * The '<em><b>Multi First</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Multi First</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MULTI_FIRST
	 * @model name="MultiFirst"
	 * @generated
	 * @ordered
	 */
	public static final int MULTI_FIRST_VALUE = 3;

	/**
	 * The '<em><b>Multi Last</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Multi Last</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MULTI_LAST
	 * @model name="MultiLast"
	 * @generated
	 * @ordered
	 */
	public static final int MULTI_LAST_VALUE = 4;

	/**
	 * The '<em><b>Multi Backward Preceding</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Multi Backward Preceding</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MULTI_BACKWARD_PRECEDING
	 * @model name="MultiBackwardPreceding"
	 * @generated
	 * @ordered
	 */
	public static final int MULTI_BACKWARD_PRECEDING_VALUE = 5;

	/**
	 * The '<em><b>Multi Backward Earliest</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Multi Backward Earliest</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MULTI_BACKWARD_EARLIEST
	 * @model name="MultiBackwardEarliest"
	 * @generated
	 * @ordered
	 */
	public static final int MULTI_BACKWARD_EARLIEST_VALUE = 6;

	/**
	 * An array of all the '<em><b>Event Chain Strategy</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final EventChainStrategy[] VALUES_ARRAY =
		new EventChainStrategy[] {
			FIRST_FIRST,
			FIRST_LAST,
			LAST_LAST,
			MULTI_FIRST,
			MULTI_LAST,
			MULTI_BACKWARD_PRECEDING,
			MULTI_BACKWARD_EARLIEST,
		};

	/**
	 * A public read-only list of all the '<em><b>Event Chain Strategy</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<EventChainStrategy> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Event Chain Strategy</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static EventChainStrategy get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			EventChainStrategy result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Event Chain Strategy</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static EventChainStrategy getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			EventChainStrategy result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Event Chain Strategy</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static EventChainStrategy get(int value) {
		switch (value) {
			case FIRST_FIRST_VALUE: return FIRST_FIRST;
			case FIRST_LAST_VALUE: return FIRST_LAST;
			case LAST_LAST_VALUE: return LAST_LAST;
			case MULTI_FIRST_VALUE: return MULTI_FIRST;
			case MULTI_LAST_VALUE: return MULTI_LAST;
			case MULTI_BACKWARD_PRECEDING_VALUE: return MULTI_BACKWARD_PRECEDING;
			case MULTI_BACKWARD_EARLIEST_VALUE: return MULTI_BACKWARD_EARLIEST;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EventChainStrategy(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //EventChainStrategy
