/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement.impl;

import com.inchron.realtime.root.model.requirement.RTOSFailure;
import com.inchron.realtime.root.model.requirement.RequirementPackage;
import com.inchron.realtime.root.model.requirement.RtosFailureRequirement;

import java.util.Collection;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Rtos Failure Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.RtosFailureRequirementImpl#getEnabledRTOSFailures <em>Enabled RTOS Failures</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.RtosFailureRequirementImpl#getBlacklist <em>Blacklist</em>}</li>
 * </ul>
 *
 * @generated
 */
public class RtosFailureRequirementImpl extends RequirementImpl implements RtosFailureRequirement {
	/**
	 * The cached value of the '{@link #getEnabledRTOSFailures() <em>Enabled RTOS Failures</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEnabledRTOSFailures()
	 * @generated
	 * @ordered
	 */
	protected EList<RTOSFailure> enabledRTOSFailures;

	/**
	 * The cached value of the '{@link #getBlacklist() <em>Blacklist</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBlacklist()
	 * @generated
	 * @ordered
	 */
	protected EList<com.inchron.realtime.root.model.Process> blacklist;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RtosFailureRequirementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RequirementPackage.Literals.RTOS_FAILURE_REQUIREMENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<RTOSFailure> getEnabledRTOSFailures() {
		if (enabledRTOSFailures == null) {
			enabledRTOSFailures = new EDataTypeUniqueEList<RTOSFailure>(RTOSFailure.class, this, RequirementPackage.RTOS_FAILURE_REQUIREMENT__ENABLED_RTOS_FAILURES);
		}
		return enabledRTOSFailures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<com.inchron.realtime.root.model.Process> getBlacklist() {
		if (blacklist == null) {
			blacklist = new EObjectResolvingEList<com.inchron.realtime.root.model.Process>(com.inchron.realtime.root.model.Process.class, this, RequirementPackage.RTOS_FAILURE_REQUIREMENT__BLACKLIST);
		}
		return blacklist;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RequirementPackage.RTOS_FAILURE_REQUIREMENT__ENABLED_RTOS_FAILURES:
				return getEnabledRTOSFailures();
			case RequirementPackage.RTOS_FAILURE_REQUIREMENT__BLACKLIST:
				return getBlacklist();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RequirementPackage.RTOS_FAILURE_REQUIREMENT__ENABLED_RTOS_FAILURES:
				getEnabledRTOSFailures().clear();
				getEnabledRTOSFailures().addAll((Collection<? extends RTOSFailure>)newValue);
				return;
			case RequirementPackage.RTOS_FAILURE_REQUIREMENT__BLACKLIST:
				getBlacklist().clear();
				getBlacklist().addAll((Collection<? extends com.inchron.realtime.root.model.Process>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RequirementPackage.RTOS_FAILURE_REQUIREMENT__ENABLED_RTOS_FAILURES:
				getEnabledRTOSFailures().clear();
				return;
			case RequirementPackage.RTOS_FAILURE_REQUIREMENT__BLACKLIST:
				getBlacklist().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RequirementPackage.RTOS_FAILURE_REQUIREMENT__ENABLED_RTOS_FAILURES:
				return enabledRTOSFailures != null && !enabledRTOSFailures.isEmpty();
			case RequirementPackage.RTOS_FAILURE_REQUIREMENT__BLACKLIST:
				return blacklist != null && !blacklist.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (enabledRTOSFailures: ");
		result.append(enabledRTOSFailures);
		result.append(')');
		return result.toString();
	}

} //RtosFailureRequirementImpl
