/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement.util;

import com.inchron.realtime.root.Referrable;

import com.inchron.realtime.root.model.ModelObject;

import com.inchron.realtime.root.model.requirement.*;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage
 * @generated
 */
public class RequirementSwitch<T> extends Switch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static RequirementPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RequirementSwitch() {
		if (modelPackage == null) {
			modelPackage = RequirementPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case RequirementPackage.CALL_NESTING_REQUIREMENT: {
				CallNestingRequirement callNestingRequirement = (CallNestingRequirement)theEObject;
				T result = caseCallNestingRequirement(callNestingRequirement);
				if (result == null) result = caseRequirement(callNestingRequirement);
				if (result == null) result = caseModelObject(callNestingRequirement);
				if (result == null) result = caseReferrable(callNestingRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.EVALUATION: {
				Evaluation evaluation = (Evaluation)theEObject;
				T result = caseEvaluation(evaluation);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.EVENT_CHAIN_BREAK_OFF_REQUIREMENT: {
				EventChainBreakOffRequirement eventChainBreakOffRequirement = (EventChainBreakOffRequirement)theEObject;
				T result = caseEventChainBreakOffRequirement(eventChainBreakOffRequirement);
				if (result == null) result = caseRequirement(eventChainBreakOffRequirement);
				if (result == null) result = caseModelObject(eventChainBreakOffRequirement);
				if (result == null) result = caseReferrable(eventChainBreakOffRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.EVENT_CHAIN_JOIN_REQUIREMENT: {
				EventChainJoinRequirement eventChainJoinRequirement = (EventChainJoinRequirement)theEObject;
				T result = caseEventChainJoinRequirement(eventChainJoinRequirement);
				if (result == null) result = caseRequirement(eventChainJoinRequirement);
				if (result == null) result = caseModelObject(eventChainJoinRequirement);
				if (result == null) result = caseReferrable(eventChainJoinRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT: {
				EventChainMultipleProcessingRequirement eventChainMultipleProcessingRequirement = (EventChainMultipleProcessingRequirement)theEObject;
				T result = caseEventChainMultipleProcessingRequirement(eventChainMultipleProcessingRequirement);
				if (result == null) result = caseRequirement(eventChainMultipleProcessingRequirement);
				if (result == null) result = caseModelObject(eventChainMultipleProcessingRequirement);
				if (result == null) result = caseReferrable(eventChainMultipleProcessingRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.EVENT_CHAIN_TIMING_REQUIREMENT: {
				EventChainTimingRequirement eventChainTimingRequirement = (EventChainTimingRequirement)theEObject;
				T result = caseEventChainTimingRequirement(eventChainTimingRequirement);
				if (result == null) result = caseTimingRequirement(eventChainTimingRequirement);
				if (result == null) result = caseRequirement(eventChainTimingRequirement);
				if (result == null) result = caseModelObject(eventChainTimingRequirement);
				if (result == null) result = caseReferrable(eventChainTimingRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.EVENT_IEVENT_JREQUIREMENT: {
				EventIEventJRequirement eventIEventJRequirement = (EventIEventJRequirement)theEObject;
				T result = caseEventIEventJRequirement(eventIEventJRequirement);
				if (result == null) result = caseTimingRequirement(eventIEventJRequirement);
				if (result == null) result = caseRequirement(eventIEventJRequirement);
				if (result == null) result = caseModelObject(eventIEventJRequirement);
				if (result == null) result = caseReferrable(eventIEventJRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.EVENT_NET_EXEC_TIME_REQUIREMENT: {
				EventNetExecTimeRequirement eventNetExecTimeRequirement = (EventNetExecTimeRequirement)theEObject;
				T result = caseEventNetExecTimeRequirement(eventNetExecTimeRequirement);
				if (result == null) result = caseTimingRequirement(eventNetExecTimeRequirement);
				if (result == null) result = caseRequirement(eventNetExecTimeRequirement);
				if (result == null) result = caseModelObject(eventNetExecTimeRequirement);
				if (result == null) result = caseReferrable(eventNetExecTimeRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.EVENT_TIMING_REQUIREMENT: {
				EventTimingRequirement eventTimingRequirement = (EventTimingRequirement)theEObject;
				T result = caseEventTimingRequirement(eventTimingRequirement);
				if (result == null) result = caseTimingRequirement(eventTimingRequirement);
				if (result == null) result = caseRequirement(eventTimingRequirement);
				if (result == null) result = caseModelObject(eventTimingRequirement);
				if (result == null) result = caseReferrable(eventTimingRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.GROUP_OF_REQUIREMENTS: {
				GroupOfRequirements groupOfRequirements = (GroupOfRequirements)theEObject;
				T result = caseGroupOfRequirements(groupOfRequirements);
				if (result == null) result = caseRequirement(groupOfRequirements);
				if (result == null) result = caseModelObject(groupOfRequirements);
				if (result == null) result = caseReferrable(groupOfRequirements);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.ILLEGAL_EVENT_REQUIREMENT: {
				IllegalEventRequirement illegalEventRequirement = (IllegalEventRequirement)theEObject;
				T result = caseIllegalEventRequirement(illegalEventRequirement);
				if (result == null) result = caseRequirement(illegalEventRequirement);
				if (result == null) result = caseModelObject(illegalEventRequirement);
				if (result == null) result = caseReferrable(illegalEventRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.LOAD_REQUIREMENT: {
				LoadRequirement loadRequirement = (LoadRequirement)theEObject;
				T result = caseLoadRequirement(loadRequirement);
				if (result == null) result = caseRequirement(loadRequirement);
				if (result == null) result = caseModelObject(loadRequirement);
				if (result == null) result = caseReferrable(loadRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.NET_EXEC_TIME_REQUIREMENT: {
				NetExecTimeRequirement netExecTimeRequirement = (NetExecTimeRequirement)theEObject;
				T result = caseNetExecTimeRequirement(netExecTimeRequirement);
				if (result == null) result = caseTimingRequirement(netExecTimeRequirement);
				if (result == null) result = caseRequirement(netExecTimeRequirement);
				if (result == null) result = caseModelObject(netExecTimeRequirement);
				if (result == null) result = caseReferrable(netExecTimeRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.NET_SLACK_TIME_REQUIREMENT: {
				NetSlackTimeRequirement netSlackTimeRequirement = (NetSlackTimeRequirement)theEObject;
				T result = caseNetSlackTimeRequirement(netSlackTimeRequirement);
				if (result == null) result = caseTimingRequirement(netSlackTimeRequirement);
				if (result == null) result = caseRequirement(netSlackTimeRequirement);
				if (result == null) result = caseModelObject(netSlackTimeRequirement);
				if (result == null) result = caseReferrable(netSlackTimeRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.PERIODIC_EVENT_REQUIREMENT: {
				PeriodicEventRequirement periodicEventRequirement = (PeriodicEventRequirement)theEObject;
				T result = casePeriodicEventRequirement(periodicEventRequirement);
				if (result == null) result = caseTimingRequirement(periodicEventRequirement);
				if (result == null) result = caseRequirement(periodicEventRequirement);
				if (result == null) result = caseModelObject(periodicEventRequirement);
				if (result == null) result = caseReferrable(periodicEventRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.RECURSION_REQUIREMENT: {
				RecursionRequirement recursionRequirement = (RecursionRequirement)theEObject;
				T result = caseRecursionRequirement(recursionRequirement);
				if (result == null) result = caseRequirement(recursionRequirement);
				if (result == null) result = caseModelObject(recursionRequirement);
				if (result == null) result = caseReferrable(recursionRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.REQUIREMENT: {
				Requirement requirement = (Requirement)theEObject;
				T result = caseRequirement(requirement);
				if (result == null) result = caseModelObject(requirement);
				if (result == null) result = caseReferrable(requirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.RESPONSE_TIME_REQUIREMENT: {
				ResponseTimeRequirement responseTimeRequirement = (ResponseTimeRequirement)theEObject;
				T result = caseResponseTimeRequirement(responseTimeRequirement);
				if (result == null) result = caseTimingRequirement(responseTimeRequirement);
				if (result == null) result = caseRequirement(responseTimeRequirement);
				if (result == null) result = caseModelObject(responseTimeRequirement);
				if (result == null) result = caseReferrable(responseTimeRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.RTOS_FAILURE_REQUIREMENT: {
				RtosFailureRequirement rtosFailureRequirement = (RtosFailureRequirement)theEObject;
				T result = caseRtosFailureRequirement(rtosFailureRequirement);
				if (result == null) result = caseRequirement(rtosFailureRequirement);
				if (result == null) result = caseModelObject(rtosFailureRequirement);
				if (result == null) result = caseReferrable(rtosFailureRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RequirementPackage.TIMING_REQUIREMENT: {
				TimingRequirement timingRequirement = (TimingRequirement)theEObject;
				T result = caseTimingRequirement(timingRequirement);
				if (result == null) result = caseRequirement(timingRequirement);
				if (result == null) result = caseModelObject(timingRequirement);
				if (result == null) result = caseReferrable(timingRequirement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Call Nesting Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Call Nesting Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCallNestingRequirement(CallNestingRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Evaluation</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Evaluation</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEvaluation(Evaluation object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Event Chain Break Off Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Event Chain Break Off Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEventChainBreakOffRequirement(EventChainBreakOffRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Event Chain Join Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Event Chain Join Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEventChainJoinRequirement(EventChainJoinRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Event Chain Multiple Processing Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Event Chain Multiple Processing Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEventChainMultipleProcessingRequirement(EventChainMultipleProcessingRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Event Chain Timing Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Event Chain Timing Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEventChainTimingRequirement(EventChainTimingRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Event IEvent JRequirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Event IEvent JRequirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEventIEventJRequirement(EventIEventJRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Event Net Exec Time Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Event Net Exec Time Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEventNetExecTimeRequirement(EventNetExecTimeRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Event Timing Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Event Timing Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEventTimingRequirement(EventTimingRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Group Of Requirements</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Group Of Requirements</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGroupOfRequirements(GroupOfRequirements object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Illegal Event Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Illegal Event Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseIllegalEventRequirement(IllegalEventRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Load Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Load Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLoadRequirement(LoadRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Net Exec Time Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Net Exec Time Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNetExecTimeRequirement(NetExecTimeRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Net Slack Time Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Net Slack Time Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNetSlackTimeRequirement(NetSlackTimeRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Periodic Event Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Periodic Event Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePeriodicEventRequirement(PeriodicEventRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Recursion Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Recursion Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRecursionRequirement(RecursionRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRequirement(Requirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Response Time Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Response Time Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseResponseTimeRequirement(ResponseTimeRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Rtos Failure Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Rtos Failure Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRtosFailureRequirement(RtosFailureRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Timing Requirement</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Timing Requirement</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTimingRequirement(TimingRequirement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Referrable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Referrable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseReferrable(Referrable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Object</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Object</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseModelObject(ModelObject object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(EObject object) {
		return null;
	}

} //RequirementSwitch
