/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation;

import com.inchron.realtime.root.model.Time;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Disturbance Filter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.DisturbanceFilter#getDisturbanceProbability <em>Disturbance Probability</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.DisturbanceFilter#getDisturbanceSigma <em>Disturbance Sigma</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.DisturbanceFilter#getLossProbability <em>Loss Probability</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getDisturbanceFilter()
 * @model
 * @generated
 */
public interface DisturbanceFilter extends StimulationFilter {
	/**
	 * Returns the value of the '<em><b>Disturbance Probability</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Disturbance Probability</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Disturbance Probability</em>' attribute.
	 * @see #setDisturbanceProbability(float)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getDisturbanceFilter_DisturbanceProbability()
	 * @model default="0"
	 * @generated
	 */
	float getDisturbanceProbability();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.DisturbanceFilter#getDisturbanceProbability <em>Disturbance Probability</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Disturbance Probability</em>' attribute.
	 * @see #getDisturbanceProbability()
	 * @generated
	 */
	void setDisturbanceProbability(float value);

	/**
	 * Returns the value of the '<em><b>Disturbance Sigma</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Disturbance Sigma</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Disturbance Sigma</em>' containment reference.
	 * @see #setDisturbanceSigma(Time)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getDisturbanceFilter_DisturbanceSigma()
	 * @model containment="true"
	 * @generated
	 */
	Time getDisturbanceSigma();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.DisturbanceFilter#getDisturbanceSigma <em>Disturbance Sigma</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Disturbance Sigma</em>' containment reference.
	 * @see #getDisturbanceSigma()
	 * @generated
	 */
	void setDisturbanceSigma(Time value);

	/**
	 * Returns the value of the '<em><b>Loss Probability</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Loss Probability</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Loss Probability</em>' attribute.
	 * @see #setLossProbability(float)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getDisturbanceFilter_LossProbability()
	 * @model default="0"
	 * @generated
	 */
	float getLossProbability();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.DisturbanceFilter#getLossProbability <em>Loss Probability</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Loss Probability</em>' attribute.
	 * @see #getLossProbability()
	 * @generated
	 */
	void setLossProbability(float value);

} // DisturbanceFilter
