/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation;

import com.inchron.realtime.root.model.Time;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Drift Filter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.DriftFilter#getMaximum <em>Maximum</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.DriftFilter#isPeriodic <em>Periodic</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.DriftFilter#getRepeat <em>Repeat</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.DriftFilter#getStartTime <em>Start Time</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.DriftFilter#getTimeFrame <em>Time Frame</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getDriftFilter()
 * @model
 * @generated
 */
public interface DriftFilter extends StimulationFilter {
	/**
	 * Returns the value of the '<em><b>Maximum</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Maximum</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Maximum</em>' containment reference.
	 * @see #setMaximum(Time)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getDriftFilter_Maximum()
	 * @model containment="true"
	 * @generated
	 */
	Time getMaximum();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.DriftFilter#getMaximum <em>Maximum</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Maximum</em>' containment reference.
	 * @see #getMaximum()
	 * @generated
	 */
	void setMaximum(Time value);

	/**
	 * Returns the value of the '<em><b>Periodic</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Periodic</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Periodic</em>' attribute.
	 * @see #setPeriodic(boolean)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getDriftFilter_Periodic()
	 * @model default="false"
	 * @generated
	 */
	boolean isPeriodic();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.DriftFilter#isPeriodic <em>Periodic</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Periodic</em>' attribute.
	 * @see #isPeriodic()
	 * @generated
	 */
	void setPeriodic(boolean value);

	/**
	 * Returns the value of the '<em><b>Repeat</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Repeat</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Repeat</em>' containment reference.
	 * @see #setRepeat(Time)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getDriftFilter_Repeat()
	 * @model containment="true"
	 * @generated
	 */
	Time getRepeat();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.DriftFilter#getRepeat <em>Repeat</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Repeat</em>' containment reference.
	 * @see #getRepeat()
	 * @generated
	 */
	void setRepeat(Time value);

	/**
	 * Returns the value of the '<em><b>Start Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Time</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Time</em>' containment reference.
	 * @see #setStartTime(Time)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getDriftFilter_StartTime()
	 * @model containment="true"
	 * @generated
	 */
	Time getStartTime();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.DriftFilter#getStartTime <em>Start Time</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start Time</em>' containment reference.
	 * @see #getStartTime()
	 * @generated
	 */
	void setStartTime(Time value);

	/**
	 * Returns the value of the '<em><b>Time Frame</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Time Frame</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Time Frame</em>' containment reference.
	 * @see #setTimeFrame(Time)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getDriftFilter_TimeFrame()
	 * @model containment="true"
	 * @generated
	 */
	Time getTimeFrame();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.DriftFilter#getTimeFrame <em>Time Frame</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Time Frame</em>' containment reference.
	 * @see #getTimeFrame()
	 * @generated
	 */
	void setTimeFrame(Time value);

} // DriftFilter
