/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation;

import com.inchron.realtime.root.model.CallGraph;
import com.inchron.realtime.root.model.ClockUser;
import com.inchron.realtime.root.model.Connection;
import com.inchron.realtime.root.model.ModelObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Stimuli Generator</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.StimuliGenerator#getConnections <em>Connections</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.StimuliGenerator#getFilters <em>Filters</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.StimuliGenerator#getTargets <em>Targets</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getStimuliGenerator()
 * @model abstract="true"
 * @generated
 */
public interface StimuliGenerator extends ModelObject, ClockUser {
	/**
	 * Returns the value of the '<em><b>Connections</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Connection}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Connections</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Connections</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getStimuliGenerator_Connections()
	 * @model containment="true"
	 * @generated
	 */
	EList<Connection> getConnections();

	/**
	 * Returns the value of the '<em><b>Filters</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.stimulation.StimulationFilter}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Filters</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Filters</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getStimuliGenerator_Filters()
	 * @model containment="true"
	 * @generated
	 */
	EList<StimulationFilter> getFilters();

	/**
	 * Returns the value of the '<em><b>Targets</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Targets</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Targets</em>' containment reference.
	 * @see #setTargets(CallGraph)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getStimuliGenerator_Targets()
	 * @model containment="true"
	 * @generated
	 */
	CallGraph getTargets();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.StimuliGenerator#getTargets <em>Targets</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Targets</em>' containment reference.
	 * @see #getTargets()
	 * @generated
	 */
	void setTargets(CallGraph value);

} // StimuliGenerator
