/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation.impl;

import com.inchron.realtime.root.model.Time;

import com.inchron.realtime.root.model.stimulation.DriftFilter;
import com.inchron.realtime.root.model.stimulation.StimulationPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Drift Filter</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.DriftFilterImpl#getMaximum <em>Maximum</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.DriftFilterImpl#isPeriodic <em>Periodic</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.DriftFilterImpl#getRepeat <em>Repeat</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.DriftFilterImpl#getStartTime <em>Start Time</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.DriftFilterImpl#getTimeFrame <em>Time Frame</em>}</li>
 * </ul>
 *
 * @generated
 */
public class DriftFilterImpl extends StimulationFilterImpl implements DriftFilter {
	/**
	 * The cached value of the '{@link #getMaximum() <em>Maximum</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaximum()
	 * @generated
	 * @ordered
	 */
	protected Time maximum;

	/**
	 * The default value of the '{@link #isPeriodic() <em>Periodic</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPeriodic()
	 * @generated
	 * @ordered
	 */
	protected static final boolean PERIODIC_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isPeriodic() <em>Periodic</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPeriodic()
	 * @generated
	 * @ordered
	 */
	protected boolean periodic = PERIODIC_EDEFAULT;

	/**
	 * The cached value of the '{@link #getRepeat() <em>Repeat</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRepeat()
	 * @generated
	 * @ordered
	 */
	protected Time repeat;

	/**
	 * The cached value of the '{@link #getStartTime() <em>Start Time</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartTime()
	 * @generated
	 * @ordered
	 */
	protected Time startTime;

	/**
	 * The cached value of the '{@link #getTimeFrame() <em>Time Frame</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTimeFrame()
	 * @generated
	 * @ordered
	 */
	protected Time timeFrame;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DriftFilterImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return StimulationPackage.Literals.DRIFT_FILTER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getMaximum() {
		return maximum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetMaximum(Time newMaximum, NotificationChain msgs) {
		Time oldMaximum = maximum;
		maximum = newMaximum;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StimulationPackage.DRIFT_FILTER__MAXIMUM, oldMaximum, newMaximum);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMaximum(Time newMaximum) {
		if (newMaximum != maximum) {
			NotificationChain msgs = null;
			if (maximum != null)
				msgs = ((InternalEObject)maximum).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.DRIFT_FILTER__MAXIMUM, null, msgs);
			if (newMaximum != null)
				msgs = ((InternalEObject)newMaximum).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.DRIFT_FILTER__MAXIMUM, null, msgs);
			msgs = basicSetMaximum(newMaximum, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.DRIFT_FILTER__MAXIMUM, newMaximum, newMaximum));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isPeriodic() {
		return periodic;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPeriodic(boolean newPeriodic) {
		boolean oldPeriodic = periodic;
		periodic = newPeriodic;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.DRIFT_FILTER__PERIODIC, oldPeriodic, periodic));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getRepeat() {
		return repeat;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetRepeat(Time newRepeat, NotificationChain msgs) {
		Time oldRepeat = repeat;
		repeat = newRepeat;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StimulationPackage.DRIFT_FILTER__REPEAT, oldRepeat, newRepeat);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRepeat(Time newRepeat) {
		if (newRepeat != repeat) {
			NotificationChain msgs = null;
			if (repeat != null)
				msgs = ((InternalEObject)repeat).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.DRIFT_FILTER__REPEAT, null, msgs);
			if (newRepeat != null)
				msgs = ((InternalEObject)newRepeat).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.DRIFT_FILTER__REPEAT, null, msgs);
			msgs = basicSetRepeat(newRepeat, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.DRIFT_FILTER__REPEAT, newRepeat, newRepeat));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getStartTime() {
		return startTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStartTime(Time newStartTime, NotificationChain msgs) {
		Time oldStartTime = startTime;
		startTime = newStartTime;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StimulationPackage.DRIFT_FILTER__START_TIME, oldStartTime, newStartTime);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartTime(Time newStartTime) {
		if (newStartTime != startTime) {
			NotificationChain msgs = null;
			if (startTime != null)
				msgs = ((InternalEObject)startTime).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.DRIFT_FILTER__START_TIME, null, msgs);
			if (newStartTime != null)
				msgs = ((InternalEObject)newStartTime).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.DRIFT_FILTER__START_TIME, null, msgs);
			msgs = basicSetStartTime(newStartTime, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.DRIFT_FILTER__START_TIME, newStartTime, newStartTime));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getTimeFrame() {
		return timeFrame;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTimeFrame(Time newTimeFrame, NotificationChain msgs) {
		Time oldTimeFrame = timeFrame;
		timeFrame = newTimeFrame;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StimulationPackage.DRIFT_FILTER__TIME_FRAME, oldTimeFrame, newTimeFrame);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTimeFrame(Time newTimeFrame) {
		if (newTimeFrame != timeFrame) {
			NotificationChain msgs = null;
			if (timeFrame != null)
				msgs = ((InternalEObject)timeFrame).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.DRIFT_FILTER__TIME_FRAME, null, msgs);
			if (newTimeFrame != null)
				msgs = ((InternalEObject)newTimeFrame).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.DRIFT_FILTER__TIME_FRAME, null, msgs);
			msgs = basicSetTimeFrame(newTimeFrame, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.DRIFT_FILTER__TIME_FRAME, newTimeFrame, newTimeFrame));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case StimulationPackage.DRIFT_FILTER__MAXIMUM:
				return basicSetMaximum(null, msgs);
			case StimulationPackage.DRIFT_FILTER__REPEAT:
				return basicSetRepeat(null, msgs);
			case StimulationPackage.DRIFT_FILTER__START_TIME:
				return basicSetStartTime(null, msgs);
			case StimulationPackage.DRIFT_FILTER__TIME_FRAME:
				return basicSetTimeFrame(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case StimulationPackage.DRIFT_FILTER__MAXIMUM:
				return getMaximum();
			case StimulationPackage.DRIFT_FILTER__PERIODIC:
				return isPeriodic();
			case StimulationPackage.DRIFT_FILTER__REPEAT:
				return getRepeat();
			case StimulationPackage.DRIFT_FILTER__START_TIME:
				return getStartTime();
			case StimulationPackage.DRIFT_FILTER__TIME_FRAME:
				return getTimeFrame();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case StimulationPackage.DRIFT_FILTER__MAXIMUM:
				setMaximum((Time)newValue);
				return;
			case StimulationPackage.DRIFT_FILTER__PERIODIC:
				setPeriodic((Boolean)newValue);
				return;
			case StimulationPackage.DRIFT_FILTER__REPEAT:
				setRepeat((Time)newValue);
				return;
			case StimulationPackage.DRIFT_FILTER__START_TIME:
				setStartTime((Time)newValue);
				return;
			case StimulationPackage.DRIFT_FILTER__TIME_FRAME:
				setTimeFrame((Time)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case StimulationPackage.DRIFT_FILTER__MAXIMUM:
				setMaximum((Time)null);
				return;
			case StimulationPackage.DRIFT_FILTER__PERIODIC:
				setPeriodic(PERIODIC_EDEFAULT);
				return;
			case StimulationPackage.DRIFT_FILTER__REPEAT:
				setRepeat((Time)null);
				return;
			case StimulationPackage.DRIFT_FILTER__START_TIME:
				setStartTime((Time)null);
				return;
			case StimulationPackage.DRIFT_FILTER__TIME_FRAME:
				setTimeFrame((Time)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case StimulationPackage.DRIFT_FILTER__MAXIMUM:
				return maximum != null;
			case StimulationPackage.DRIFT_FILTER__PERIODIC:
				return periodic != PERIODIC_EDEFAULT;
			case StimulationPackage.DRIFT_FILTER__REPEAT:
				return repeat != null;
			case StimulationPackage.DRIFT_FILTER__START_TIME:
				return startTime != null;
			case StimulationPackage.DRIFT_FILTER__TIME_FRAME:
				return timeFrame != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (periodic: ");
		result.append(periodic);
		result.append(')');
		return result.toString();
	}

} //DriftFilterImpl
