/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation.impl;

import com.inchron.realtime.root.model.Time;

import com.inchron.realtime.root.model.stimulation.ListBasedGenerator;
import com.inchron.realtime.root.model.stimulation.StimulationPackage;
import com.inchron.realtime.root.model.stimulation.StimuliGenerator;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>List Based Generator</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.ListBasedGeneratorImpl#getEntry <em>Entry</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.ListBasedGeneratorImpl#getSourceGenerator <em>Source Generator</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ListBasedGeneratorImpl extends StimuliGeneratorImpl implements ListBasedGenerator {
	/**
	 * The cached value of the '{@link #getEntry() <em>Entry</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEntry()
	 * @generated
	 * @ordered
	 */
	protected EList<Time> entry;

	/**
	 * The cached value of the '{@link #getSourceGenerator() <em>Source Generator</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSourceGenerator()
	 * @generated
	 * @ordered
	 */
	protected StimuliGenerator sourceGenerator;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ListBasedGeneratorImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return StimulationPackage.Literals.LIST_BASED_GENERATOR;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Time> getEntry() {
		if (entry == null) {
			entry = new EObjectContainmentEList<Time>(Time.class, this, StimulationPackage.LIST_BASED_GENERATOR__ENTRY);
		}
		return entry;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StimuliGenerator getSourceGenerator() {
		if (sourceGenerator != null && sourceGenerator.eIsProxy()) {
			InternalEObject oldSourceGenerator = (InternalEObject)sourceGenerator;
			sourceGenerator = (StimuliGenerator)eResolveProxy(oldSourceGenerator);
			if (sourceGenerator != oldSourceGenerator) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, StimulationPackage.LIST_BASED_GENERATOR__SOURCE_GENERATOR, oldSourceGenerator, sourceGenerator));
			}
		}
		return sourceGenerator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StimuliGenerator basicGetSourceGenerator() {
		return sourceGenerator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSourceGenerator(StimuliGenerator newSourceGenerator) {
		StimuliGenerator oldSourceGenerator = sourceGenerator;
		sourceGenerator = newSourceGenerator;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.LIST_BASED_GENERATOR__SOURCE_GENERATOR, oldSourceGenerator, sourceGenerator));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case StimulationPackage.LIST_BASED_GENERATOR__ENTRY:
				return ((InternalEList<?>)getEntry()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case StimulationPackage.LIST_BASED_GENERATOR__ENTRY:
				return getEntry();
			case StimulationPackage.LIST_BASED_GENERATOR__SOURCE_GENERATOR:
				if (resolve) return getSourceGenerator();
				return basicGetSourceGenerator();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case StimulationPackage.LIST_BASED_GENERATOR__ENTRY:
				getEntry().clear();
				getEntry().addAll((Collection<? extends Time>)newValue);
				return;
			case StimulationPackage.LIST_BASED_GENERATOR__SOURCE_GENERATOR:
				setSourceGenerator((StimuliGenerator)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case StimulationPackage.LIST_BASED_GENERATOR__ENTRY:
				getEntry().clear();
				return;
			case StimulationPackage.LIST_BASED_GENERATOR__SOURCE_GENERATOR:
				setSourceGenerator((StimuliGenerator)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case StimulationPackage.LIST_BASED_GENERATOR__ENTRY:
				return entry != null && !entry.isEmpty();
			case StimulationPackage.LIST_BASED_GENERATOR__SOURCE_GENERATOR:
				return sourceGenerator != null;
		}
		return super.eIsSet(featureID);
	}

} //ListBasedGeneratorImpl
