/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.settings;

import com.inchron.realtime.root.model.TraceEventType;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Trace Event Type Configuration</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.settings.TraceEventTypeConfiguration#getColor <em>Color</em>}</li>
 *   <li>{@link com.inchron.realtime.root.settings.TraceEventTypeConfiguration#getTraceEventType <em>Trace Event Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.settings.TraceEventTypeConfiguration#isVisible <em>Visible</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.settings.SettingsPackage#getTraceEventTypeConfiguration()
 * @model
 * @generated
 */
public interface TraceEventTypeConfiguration extends EObject {
	/**
	 * Returns the value of the '<em><b>Color</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Color</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Color</em>' reference.
	 * @see #setColor(Color)
	 * @see com.inchron.realtime.root.settings.SettingsPackage#getTraceEventTypeConfiguration_Color()
	 * @model required="true"
	 * @generated
	 */
	Color getColor();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.settings.TraceEventTypeConfiguration#getColor <em>Color</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Color</em>' reference.
	 * @see #getColor()
	 * @generated
	 */
	void setColor(Color value);

	/**
	 * Returns the value of the '<em><b>Trace Event Type</b></em>' attribute.
	 * The default value is <code>"Activate"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.TraceEventType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Trace Event Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Trace Event Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.TraceEventType
	 * @see #setTraceEventType(TraceEventType)
	 * @see com.inchron.realtime.root.settings.SettingsPackage#getTraceEventTypeConfiguration_TraceEventType()
	 * @model default="Activate"
	 * @generated
	 */
	TraceEventType getTraceEventType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.settings.TraceEventTypeConfiguration#getTraceEventType <em>Trace Event Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Trace Event Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.TraceEventType
	 * @see #getTraceEventType()
	 * @generated
	 */
	void setTraceEventType(TraceEventType value);

	/**
	 * Returns the value of the '<em><b>Visible</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Visible</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Visible</em>' attribute.
	 * @see #setVisible(boolean)
	 * @see com.inchron.realtime.root.settings.SettingsPackage#getTraceEventTypeConfiguration_Visible()
	 * @model default="true"
	 * @generated
	 */
	boolean isVisible();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.settings.TraceEventTypeConfiguration#isVisible <em>Visible</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Visible</em>' attribute.
	 * @see #isVisible()
	 * @generated
	 */
	void setVisible(boolean value);

} // TraceEventTypeConfiguration
