/**
 ********************************************************************************
 * Copyright (c) 2018-2019 Robert Bosch GmbH.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *     Robert Bosch GmbH - initial API and implementation
 ********************************************************************************
 */

package module;

import org.eclipse.app4mc.transformation.extensions.AbstractTransformationInjectorModule;
import org.eclipse.app4mc.transformation.extensions.base.templates.Model2ModelRootTransformer;

import templates.m2m.Amlt2InchronTransformer;

public class DefaultM2MInjectorModule extends AbstractTransformationInjectorModule {

	@Override
	protected void initializeBaseConfiguration() {
		bind(Model2ModelRootTransformer.class).to(Amlt2InchronTransformer.class);
		
		// base transformers
		//bind(ModelTransformer.class).to(UserDefined_ModelTransformer.class);
		//bind(SettingsTransformer.class).to(UserDefined_SettingsTransformer.class);

		// constraints
		//bind(ConstraintsTransformer.class).to(UserDefined_ConstraintsTransformer.class);
		//bind(EventChainReferenceTransformer.class).to(UserDefined_EventChainReferenceTransformer.class);
		//bind(EventChainTransformer.class).to(UserDefined_EventChainTransformer.class);

		// hw
		//bind(CacheTransformer.class).to(UserDefined_CacheTransformer.class);
		//bind(FrequencyDomainTransformer.class).to(UserDefined_FrequencyDomainTransformer.class);
		//bind(HWStructure_ECUTransformer.class).to(UserDefined_HWStructure_ECUTransformer.class);
		//bind(HWStructure_MicroControllerTransformer.class).to(UserDefined_HWStructure_MicroControllerTransformer.class);
		//bind(HWStructure_SystemTransformer.class).to(UserDefined_HWStructure_SystemTransformer.class);
		//bind(HWTransformer.class).to(UserDefined_HWTransformer.class);
		//bind(MemoryTransformer.class).to(UserDefined_MemoryTransformer.class);
		//bind(ProcessingUnitTransformer.class).to(UserDefined_ProcessingUnitTransformer.class);

		// mapping
		//bind(MappingTransformer.class).to(UserDefined_MappingTransformer.class);

		// os
		//bind(OSTransformer.class).to(UserDefined_OSTransformer.class);

		// stimuli
		//bind(StimuliTransformer.class).to(UserDefined_StimuliTransformer.class);

		// sw
		//bind(CallGraphTransformer.class).to(UserDefined_CallGraphTransformer.class);
		//bind(ChannelTransformer.class).to(UserDefined_ChannelTransformer.class);
		//bind(CustomEventTriggerTransformer.class).to(UserDefined_CustomEventTriggerTransformer.class);
		//bind(GraphEntryBaseTransformer.class).to(UserDefined_GraphEntryBaseTransformer.class);
		//bind(ISRTransformer.class).to(UserDefined_ISRTransformer.class);
		//bind(ModeLabelTransformer.class).to(UserDefined_ModeLabelTransformer.class);
		//bind(ModeSwitchTransformer.class).to(UserDefined_ModeSwitchTransformer.class);
		//bind(ModeValueDisjunctionTransformer.class).to(UserDefined_ModeValueDisjunctionTransformer.class);
		//bind(RunnableItemTransformer.class).to(UserDefined_RunnableItemTransformer.class);
		//bind(RunnableTransformer.class).to(UserDefined_RunnableTransformer.class);
		//bind(SWTransformer.class).to(UserDefined_SWTransformer.class);
		//bind(TaskTransformer.class).to(UserDefined_TaskTransformer.class);

		// sw/runnableItem/
		//bind(AsynchronousServerCallTransformer.class).to(UserDefined_AsynchronousServerCallTransformer.class);
		//bind(ChannelAccessTransformer.class).to(UserDefined_ChannelAccessTransformer.class);
		//bind(ComputationItemTransformer.class).to(UserDefined_ComputationItemTransformer.class);
		//bind(CustomEventTriggerTransformer.class).to(UserDefined_CustomEventTriggerTransformer.class);
		//bind(ExecutionNeedTransformer.class).to(UserDefined_ExecutionNeedTransformer.class);
		//bind(GetResultServerCallTransformer.class).to(UserDefined_GetResultServerCallTransformer.class);
		//bind(GroupTransformer.class).to(UserDefined_GroupTransformer.class);
		//bind(LabelAccessTransformer.class).to(UserDefined_LabelAccessTransformer.class);
		//bind(ModeLabelAccessTransformer.class).to(UserDefined_ModeLabelAccessTransformer.class);
		//bind(RunnableCallTransformer.class).to(UserDefined_RunnableCallTransformer.class);
		//bind(RunnableModeSwitchTransformer.class).to(UserDefined_RunnableModeSwitchTransformer.class);
		//bind(RunnableProbablilitySwitchTransformer.class).to(UserDefined_RunnableProbablilitySwitchTransformer.class);
		//bind(SemaphoreAccessTransformer.class).to(UserDefined_SemaphoreAccessTransformer.class);
		//bind(SenderReceiverCommunicationTransformer.class).to(UserDefined_SenderReceiverCommunicationTransformer.class);
		//bind(SenderReceiverReadTransformer.class).to(UserDefined_SenderReceiverReadTransformer.class);
		//bind(SenderReceiverWriteTransformer.class).to(UserDefined_SenderReceiverWriteTransformer.class);
		//bind(ServerCallTransformer.class).to(UserDefined_ServerCallTransformer.class);
		//bind(SynchronousServerCallTransformer.class).to(UserDefined_SynchronousServerCallTransformer.class);
		//bind(TicksTransformer.class).to(UserDefined_TicksTransformer.class);
		//bind(TransmissionPolicyTransformer.class).to(UserDefined_TransmissionPolicyTransformer.class);

		// utils 
		//bind(FrequencyTransformer.class).to(UserDefined_FrequencyTransformer.class);
		//bind(TimeTransformer.class).to(UserDefined_TimeTransformer.class);




	}

	@Override
	protected void initializeTransformerObjects() {
	}

}
