/**
 * *******************************************************************************
 * Copyright (c) 2019 Robert Bosch GmbH and others.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     Robert Bosch GmbH - initial API and implementation
 * *******************************************************************************
 */

package templates.m2m.sw

import com.inchron.realtime.root.model.Component
import org.eclipse.app4mc.amalthea.model.ISR
import templates.AbstractAmaltheaInchronTransformer
import templates.utils.AmltCacheModel
import com.google.inject.Singleton

@Singleton
class ISRTransformer extends AbstractAmaltheaInchronTransformer {

	var AmltCacheModel cacheModel

	def create inchronModelFactory.createProcess createProcess(ISR amltISR, Component inchronComponent) {

		cacheModel = customObjsStore.getInstance(AmltCacheModel)

		it.name = amltISR.name

		cacheModel.addAmltProcess_InchronComponent(amltISR, inchronComponent)

		it.isr = true
	}

}
