/**
 ********************************************************************************
 * Copyright (c) 2018-2019 Robert Bosch GmbH.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *     Robert Bosch GmbH - initial API and implementation
 ********************************************************************************
 */

package org.eclipse.app4mc.transformation.extensions;

import com.google.inject.AbstractModule;

public abstract class AbstractTransformationInjectorModule extends AbstractModule {

	
	@Override
	protected void configure() {
		initializeBaseConfiguration();
		initializeTransformerObjects();
	}
	
	abstract protected void initializeBaseConfiguration() ;
	abstract protected void initializeTransformerObjects();

}
