/* ========================================================================
 * PlantUML : a free UML diagram generator
 * ========================================================================
 *
 * (C) Copyright 2009-2014, Arnaud Roques
 *
 * Project Info:  http://plantuml.sourceforge.net
 * 
 * This file is part of PlantUML.
 *
 * THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS ECLIPSE PUBLIC
 * LICENSE ("AGREEMENT"). [Eclipse Public License - v 1.0]
 * 
 * ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
 * RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.
 * 
 * You may obtain a copy of the License at
 * 
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 *
 * Original Author:  Arnaud Roques
 */
package net.sourceforge.plantuml.project;

import java.util.ArrayList;
import java.util.EnumSet;
import java.util.List;

public enum WeekDay {

	SUN, MON, TUE, WED, THU, FRI, SAT;

	public WeekDay next() {
		if (this.ordinal() == 6) {
			return SUN;
		}
		final List<WeekDay> all = new ArrayList<WeekDay>(EnumSet.allOf(WeekDay.class));
		return all.get(this.ordinal() + 1);
	}

	public WeekDay prev() {
		if (this.ordinal() == 0) {
			return SAT;
		}
		final List<WeekDay> all = new ArrayList<WeekDay>(EnumSet.allOf(WeekDay.class));
		return all.get(this.ordinal() - 1);
	}

}
